function [ phase_corr,relevant_data,shed_int,peak_values,E_backtrafo,focus_phase_corr_E,text ] = APHEFIS_CORRECTION( in_focus_int,parameters,num_peaks,fast,dxa, lambda, focus, zeropad_factor,apdiameter_meter,focus_sup,afairy )
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

tic
min_P=0.9;
max_peaks=max(num_peaks,50);

E_backtrafo=0;
focal_int_peaks_bin = imregionalmax(in_focus_int,8);
toc
% 'Watershed'
tic
shed_int = watershed(-in_focus_int); % watershed-regions of the negated intensity matrix, shows similar behaviour as phase-sign matrix!    
text='';  
toc
tic
for i=2:(size(shed_int,1)-1)
    for j=2:(size(shed_int,2)-1)
       if shed_int(i,j)==0
            xr=1;
            yr=1;
            while xr==0&&yr==0
               xr=randi([0,2])-1;
               yr=randi([0,2])-1;
            end
            g=1;
            while (shed_int(i+xr,j+yr)==0)&&g<8
               if (xr==-1&&yr<1)
                   yr=yr+1;
               elseif (yr==-1&&xr>-1)
                   xr=xr-1;
               elseif (xr==1&&yr>-1)
                   yr=yr-1;
               else
                   xr=xr+1;
               end
                   
               g=g+1;
            end
            shed_int(i,j)=shed_int(i+xr,j+yr);
            
       end
    end
end
% 
shed_int(shed_int==0)=max(max(shed_int))+1;

% find "num_peaks" highest peaks, if nearestpeaks its 0, or the num_peaks nearer to 
% the maximum, if it's 1, sort them in descreasing order. Returns coordinates and values
focal_int_peaks = focal_int_peaks_bin .* in_focus_int;
peak_values = peaks_xy_dg_mod(focal_int_peaks,shed_int,num_peaks+max_peaks*(num_peaks==0),0);

max_peaks=size(peak_values,1);
if num_peaks>max_peaks
    num_peaks=max_peaks;
end

focus_phase_corr_E = zeros(size(in_focus_int,1),size(in_focus_int,2));


totalp=0;
i=0;
while ((totalp<min_P)&&((num_peaks==0)||(num_peaks==max_peaks))&&(i<max_peaks))||(i<10)||(i<num_peaks)
    i=i+1;
    relevant_data.P_zone(i,1)=sum(sum(in_focus_int(shed_int==shed_int( peak_values(i,1) , peak_values(i,2) ))))*focus_sup;
    totalp=totalp+relevant_data.P_zone(i,1);
    relevant_data.airy_phase_vec(i,1)=angle(sum(sum(exp(1i*afairy(shed_int==shed_int( peak_values(i,1) , peak_values(i,2) ))).*in_focus_int(shed_int==shed_int( peak_values(i,1) , peak_values(i,2) )))));
    relevant_data.airy_phase_vec(i,1)=relevant_data.airy_phase_vec(i,1)-2*pi*(relevant_data.airy_phase_vec(i,1)>pi)+2*pi*(relevant_data.airy_phase_vec(i,1)<=-pi);
end

peak_values=peak_values(1:i,:);
m=i;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Fixing Parameters for the network %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
relevant_data.apdiameter_meter=apdiameter_meter;
relevant_data.distances=zeros(m) ;  
relevant_data.deviation=zeros(m) ; 
relevant_data.minimum=zeros(m) ; 
relevant_data.mean=zeros(m) ; 
relevant_data.area_zone=zeros(m,1);
% relevant_data.P_zone=zeros(m,1);
relevant_data.sorted_distances=zeros(m) ;  
relevant_data.sorted_deviation=zeros(m) ; 
relevant_data.sorted_minimum=zeros(m) ; 
relevant_data.sorted_mean=zeros(m) ; 
relevant_data.sorted_area_zone=zeros(m);
relevant_data.sorted_P_zone=zeros(m);
relevant_data.sorted_peak_values=zeros(m);

% fake value, we should pass the real ones 
relevant_data.best_phase_vec=zeros(1,m);
relevant_data.metric_values=0;

relevant_data.sorting_index=zeros(m);
relevant_data.peak_values=peak_values(:,3);

for vec_a=1:m % counter for matrix-para, start peak
    for vec_b=1:m % counter for matrix-para, other peak 
        if vec_a ~= vec_b
            prof_vec = improfile(in_focus_int, [peak_values(vec_a,2) peak_values(vec_b,2)] , [peak_values(vec_a,1) peak_values(vec_b,1)] ); % profile-vectors
            relevant_data.dist_x(vec_b,vec_a)=peak_values(vec_a,2)-peak_values(vec_b,2);
            relevant_data.dist_y(vec_b,vec_a)=peak_values(vec_a,1)-peak_values(vec_b,1);
            relevant_data.distances(vec_b,vec_a) = length(prof_vec);
            relevant_data.deviation(vec_b,vec_a) = -var(prof_vec)^0.5; 
            relevant_data.minimum(vec_b,vec_a)= min(prof_vec);
            relevant_data.mean(vec_b,vec_a)=mean(prof_vec);
        end 
    end
    relevant_data.area_zone(vec_a,1)=sum(sum(shed_int==shed_int( peak_values(vec_a,1) , peak_values(vec_a,2) )));
%     relevant_data.P_zone(vec_a,1)=sum(sum(in_focus_int(shed_int==shed_int( peak_values(vec_a,1) , peak_values(vec_a,2) ))))*focus_sup;
    relevant_data.true_phase(vec_a)=0;% fake value, we should pass the real        
    
    [relevant_data.sorted_distances(:,vec_a),relevant_data.sorting_index(:,vec_a)]=sort(relevant_data.distances(:,vec_a));
    relevant_data.sorted_minimum(:,vec_a)=relevant_data.minimum(relevant_data.sorting_index(:,vec_a),vec_a);
    relevant_data.sorted_mean(:,vec_a)=relevant_data.mean(relevant_data.sorting_index(:,vec_a),vec_a);
    relevant_data.sorted_deviation(:,vec_a)=relevant_data.deviation(relevant_data.sorting_index(:,vec_a),vec_a);    
end

relevant_data.sorted_area_zone=relevant_data.area_zone(relevant_data.sorting_index);
relevant_data.sorted_P_zone=relevant_data.P_zone(relevant_data.sorting_index);
relevant_data.sorted_peak_values=relevant_data.peak_values(relevant_data.sorting_index);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Aply the network %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
toc
% 'Network'
tic
phase_corr=0;
if ~fast
    [text,relevant_data.phase_vec]=neural_network(parameters,{relevant_data});
else
    relevant_data.phase_vec=ones(m,1);
end
toc
tic
if fast~=1
    relevant_data.phase_vec(relevant_data.phase_vec==0)=-1;
    for k=1:m
        focus_phase_corr_E(shed_int==shed_int( peak_values(k,1) , peak_values(k,2) ))=relevant_data.phase_vec(k,1) * pi/2;
    end
%     shed_int(focus_phase_corr_E==0)=0;
    
    if fast==0
        in_focus_int(focus_phase_corr_E==0)=0;
        
        E_corrected_focus = (in_focus_int.^0.5) .* exp(1i*focus_phase_corr_E);  
        E_backtrafo = backtransformation(E_corrected_focus, dxa, lambda, focus, zeropad_factor); 

        phase_corr=angle(E_backtrafo);
    end
end    
toc



end

