function varargout = APHEFIS_GUI(varargin)
% APHEFIS_GUI MATLAB code for APHEFIS_GUI.fig
%      APHEFIS_GUI, by itself, creates a new APHEFIS_GUI or raises the existing
%      singleton*.
%
%      H = APHEFIS_GUI returns the handle to a new APHEFIS_GUI or the handle to
%      the existing singleton*.
%
%      APHEFIS_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in APHEFIS_GUI.M with the given input arguments.
%
%      APHEFIS_GUI('Property','Value',...) creates a new APHEFIS_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before APHEFIS_GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to APHEFIS_GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help APHEFIS_GUI

% Last Modified by GUIDE v2.5 27-Mar-2012 14:09:54

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @APHEFIS_GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @APHEFIS_GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before APHEFIS_GUI is made visible.
function APHEFIS_GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to APHEFIS_GUI (see VARARGIN)


% Choose default command line output for APHEFIS_GUI
handles.output = hObject;
handles.data_t=[];
handles.searching=[];
handles.num_metrics=5;
handles.cr_input=[];
handles.results_table=Results_table();
handles.peaks=':';
close(handles.results_table)
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes APHEFIS_GUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = APHEFIS_GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in start.
function start_Callback(hObject, eventdata, handles)
% hObject    handle to start (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.start,'String','Processing...')
%set(handles.start,'Enable','Inactive')

set(handles.etextmessage,'String',' ')

text=[];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% New Simulation with Neural Network %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if get(handles.menusimulation,'Value')==1&&get(handles.ezernuse,'Value')==1&&get(handles.ezernnew,'Value')==0&&get(handles.ezernin,'Value')==0&&(get(handles.ezernerror,'Value')==0)&&isstruct(handles.data_t)
    
    zernikeN=str2num(get(handles.ezernorder,'String'));
    
    fflim=size(handles.data_t.rows,2);
    for f=1:fflim
        error=1;
        while error&&f<=fflim
            try
                disp(['field ' num2str(f) ' of ' num2str(fflim) '...']);
    
                fin=load(['./Images/Inputs128/' num2str(handles.cr_input.data(f,handles.cr_input.iiangle)) 'degrees/Aperture' num2str(handles.cr_input.data(f,handles.cr_input.iapdiameter_meter)) 'm/Inputfield_' num2str(handles.cr_input.data(f,handles.cr_input.ibase_field)) '.mat'],'-mat');
                fout=load(['./Images/Outputs128/' num2str(handles.cr_input.data(f,handles.cr_input.iiangle)) 'degrees/Aperture' num2str(handles.cr_input.data(f,handles.cr_input.iapdiameter_meter)) 'm/Outputfield_' num2str(handles.cr_input.data(f,handles.cr_input.ibase_field)) '.mat'],'-mat');
                error=0;
            catch err
                disp('Error!!!!')
                handles=APHEFIS_cut(handles,[1:f-1,f+1:fflim]);
                fflim=fflim-1;
            end
        end
        if f<=fflim
                
            fin=fin.field_apmask;
            fout=fout.E_corrected_field;
    
            imin=angle(fin);
            imout=angle(fout);
    
            [ain,phiRec1,rmsi]=MatchZernike(imin,zernikeN);
            [aout,phiRec2,rmso]=MatchZernike(imout,zernikeN);
    
            handles.data_t.Zern_in{f}=ain;
            handles.data_t.rms_in(f)=rmsi;
            handles.data_t.Zern_out{f}=aout;
            handles.data_t.rms_out(f)=rmso;
        end

    end

elseif get(handles.menusimulation,'Value')==1&&(isfield(handles, 'param')||(str2num(get(handles.efake,'String'))~=0)||(get(handles.efast,'Value')==1))
    
    nfields=str2num(get(handles.enfields,'String'));
    base_field=str2num(get(handles.ebase_field,'String'));
    if nfields==1000
        base_field=1;
    elseif base_field==0
        base_field=randi(1000-nfields)+1;
    end
    
    
    if isstruct(handles.data_t)&&get(handles.ezernnew,'Value')
            prev=handles.cr_input;
    else
            prev=0;
    end
    
    
    
    if ~isfield(handles, 'param')
        handles.param={0};
    elseif ~iscell(handles.param)
        handles.param={handles.param};
    end
    
    zernoptions=get(handles.esorting,'Value');
    if get(handles.ezernerror,'Value')==1
        zernoptions=zernoptions+20;
        set(handles.ezernin,'Value',0);
    elseif get(handles.ezernin,'Value')==1
        zernoptions=zernoptions+10;
    end
    
    if get(handles.ezernodd,'Value')*get(handles.ezerneven,'Value')~=1
        zernoptions=zernoptions+200*get(handles.ezernodd,'Value')+100*get(handles.ezerneven,'Value');
    end
    
    if ~get(handles.ezernnew,'Value')&&isstruct(handles.data_t)&&((zernoptions>1)||(str2num(get(handles.ezernorder,'String'))*get(handles.ezernuse,'Value')>0))
        z=1;
        nfields=size(handles.data_t.rows,2);
        if (~get(handles.ezernuse,'Value'))%&&(~isfield(handles.data_t.data,'Zern_in'))
            set(handles.ezernuse,'Value',1);
        end
        prev=0;
    else
        z=0;
    end
    
    
    
    
    for i=1:nfields
%         tic
        disp(['Field number:' num2str(i)])
%         if isfield(handles.data_t,'Zern_in')&&get(handles.ezernuse,'Value')
%             auxzern.ain=handles.data_t.Zern_in{i};
%             auxzern.rmsi=handles.data_t.rms_in{i};
%             auxzern.aout=handles.data_t.Zern_out{i};
%             auxzern.rmso=handles.data_t.rms_out{i};
%         else
            auxzern=str2num(get(handles.ezernorder,'String'))*get(handles.ezernuse,'Value');
%         end
        if (z==0)
            [num_results_,text_,rows_,columns,cr_input,relevant_data_,zern]=APHEFIS_bridge(str2num(get(handles.enum_peaks,'String')),str2num(get(handles.ezoomfa,'String')),0,...
                auxzern,get(handles.efast,'Value'),256,str2num(get(handles.eapdiameter_meter,'String')),...
                str2num(get(handles.efieldsize_m,'String')),str2num(get(handles.elambda,'String'))*1e-9,str2num(get(handles.eiangle,'String')),base_field+i-1,...
                str2num(get(handles.eiterations,'String')),str2num(get(handles.efake,'String')),zernoptions,handles.param,prev);
        else
            [num_results_,text_,rows_,columns,cr_input,relevant_data_,zern]=APHEFIS_bridge(handles.cr_input.data(i,handles.cr_input.inum_peaks),str2num(get(handles.ezoomfa,'String')),...
                0,str2num(get(handles.ezernorder,'String'))*get(handles.ezernuse,'Value'),get(handles.efast,'Value'),256,handles.cr_input.data(i,handles.cr_input.iapdiameter_meter),...
                handles.cr_input.data(i,handles.cr_input.ifieldsize_m),handles.cr_input.data(i,handles.cr_input.ilambda),handles.cr_input.data(i,handles.cr_input.iiangle),...
                handles.cr_input.data(i,handles.cr_input.ibase_field),handles.cr_input.data(i,handles.cr_input.iiterations),handles.cr_input.data(i,handles.cr_input.ifake_metric),...
                handles.cr_input.data(i,handles.cr_input.izernoptions),handles.param,prev);
        end
        
        prev=cr_input;
        if i==1
            num_results=num_results_;
            rows=rows_;
            text=text_;
            relevant_data=relevant_data_;
            if isstruct(zern)
                ain=zern.ain;
                rmsi=zern.rmsi;
                aout=zern.aout;
                rmso=zern.rmso;
            end
        else
            num_results=[num_results;num_results_];
            rows=[rows rows_{:}];
            text=[text text_];
            relevant_data=[relevant_data relevant_data_{:}]; 
            if isstruct(zern)
                ain{i}=zern.ain{1};
                rmsi(i)=zern.rmsi;
                aout{i}=zern.aout{1};
                rmso(i)=zern.rmso;
            end
        end
%         toc
    end   
            handles.cr_input=cr_input;
            
            if isstruct(handles.data_t)==0||get(handles.ezernnew,'Value')==0
                handles.data_t.data(:,1)=1:size(num_results,1);
                handles.data_t.data(:,2:size(num_results,2)+1)=num_results;
                handles.data_t.columns={'Index',columns{:}};
                handles.data_t.iIndex=1;
                for j=1:size(columns,2)
                        eval(['handles.data_t.i',columns{j},'=',num2str(j+1),';']);
                end
                handles.data_t.rows={rows{:}};
                handles.cr_input.data(:,1)=handles.data_t.data(:,1);
                handles.data_t.relevant_data=relevant_data;
                guidata(hObject,handles);
                handles=guidata(hObject);
                if isstruct(zern)
                    handles.data_t.Zern_in=ain;
                    handles.data_t.rms_in=rmsi;
                    handles.data_t.Zern_out=aout;
                    handles.data_t.rms_out=rmso;
                end
            else
                aux(:,1)=size(handles.data_t.data,1)+1:(size(handles.data_t.data,1)+size(num_results,1));
                aux(:,2:size(num_results,2)+1)=num_results;
                handles.data_t.data=[handles.data_t.data;aux];
                handles.cr_input.data(:,1)=handles.data_t.data(:,1);
                handles.data_t.rows=[handles.data_t.rows rows{:}];
                handles.data_t.relevant_data=[handles.data_t.relevant_data relevant_data{:}] ;
                if isstruct(zern)
                    handles.data_t.Zern_in=[handles.data_t.Zern_in ain];
                    handles.data_t.rms_in=[handles.data_t.rms_in rmsi];
                    handles.data_t.Zern_out=[handles.data_t.Zern_out aout];
                    handles.data_t.rms_out=[handles.data_t.rms_out rmso];
                end
            end
    
%             guidata(hObject,handles);
%             handles=guidata(hObject);            
        
   
    handles.static_stadistics=static_metrics_stadistics(handles.data_t,handles.cr_input);
    guidata(hObject,handles);
    handles=guidata(hObject);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Train Neural Network with the current data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
elseif get(handles.menusimulation,'Value')==2
    if isstruct(handles.data_t)
        if ~get(handles.enewparameters,'Value')&&isfield(handles, 'param')          
            if ~iscell(handles.param)
               p_param={handles.param};
            else
                p_param=handles.param;
            end
                
        else
            p_param=0;
        end
        [handles.param,ccef,text]=optimize_metric(handles.data_t.relevant_data,str2num(get(handles.ehiddenlayers,'String')),str2num(get(handles.elearninglambda,'String')),...
            str2num(get(handles.elearningiterations,'String')),':',str2num(get(handles.elearningdata,'String')),str2num(get(handles.elearningmodel,'String')),p_param);
    end
    guidata(hObject,handles);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Use Neural Network with the current data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
elseif get(handles.menusimulation,'Value')==3
    if isstruct(handles.data_t)&&isfield(handles, 'param')
        if iscell(handles.param)
            text=neural_network(handles.param,handles.data_t.relevant_data);
        else
            text=neural_network({handles.param},handles.data_t.relevant_data);
        end
    end    
end

set(handles.etextmessage,'String',text)



set(handles.start,'String','Start Simulation')
set(handles.start,'Enable','on')





% --- Executes on button press in eclear.
function eclear_Callback(hObject, eventdata, handles)
% hObject    handle to eclear (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.data_t=[];
set(handles.menutable,'Value',1);
set(handles.rxaxis,'Value',1);
set(handles.ryaxis,'Value',1);
set(handles.rxaxis,'String',' ');
set(handles.ryaxis,'String',' ');
if isstruct(handles.searching)
    set(handles.menutable,'String',handles.searching.basicmenu);
    handles.searching=[];
end
if ishandle(handles.results_table)
    close(handles.results_table)
end
guidata(gcbo,handles);


% --- Executes on button press in psaveparam.
function psaveparam_Callback(hObject, eventdata, handles)
% hObject    handle to psaveparam (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if isfield(handles,'param')
    [FileName,PathName,FilterIndex] = uiputfile('.mat','File to Save the Parameters:','param1.m');

    if sum(FileName)
        param=handles.param;
        save([PathName,FileName],'param')
    end
end

% --- Executes on button press in ploadparam.
function ploadparam_Callback(hObject, eventdata, handles)
% hObject    handle to ploadparam (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[FileName,PathName,~] = uigetfile('.mat','File to Load the Data From:','APHEFIS_DATA.aph');
if FileName~=0
    temp=load([PathName,FileName],'-mat');
    if isfield(temp,'param')
        handles.param=temp.param;
        guidata(hObject,handles);
    end
end


% --- Executes on button press in bsave.
function bsave_Callback(hObject, eventdata, handles)
% hObject    handle to bsave (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if isstruct(handles.data_t)
    [FileName,PathName,FilterIndex] = uiputfile('.aph','File to Save the Data:','APHEFIS_DATA.aph');

    if sum(FileName)
        temp.data_t=handles.data_t;
        temp.static_stadistics=handles.static_stadistics;
        temp.cr_input=handles.cr_input;
        APHEFIS_DATA=temp;
        save([PathName,FileName],'APHEFIS_DATA','-v7.3')
    end
end

% --- Executes on button press in bload.
function bload_Callback(hObject, eventdata, handles)
% hObject    handle to bload (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[FileName,PathName,FilterIndex] = uigetfile('.aph','File to Load the Data From:','APHEFIS_DATA.aph');
if FileName~=0
    temp=load([PathName,FileName],'-mat');
    if isfield(temp,'APHEFIS_DATA')&&isfield(temp.APHEFIS_DATA,'data_t')&&isstruct(temp.APHEFIS_DATA.data_t)
        temp=temp.APHEFIS_DATA;
        if ~get(handles.eloadadd,'value')||~isstruct(handles.data_t)
            handles.data_t=temp.data_t;
            handles.cr_input=temp.cr_input;
            handles.static_stadistics=temp.static_stadistics;
            if ~isfield(handles.data_t,'relevant_data')
                handles.data_t.relevant_data=cell(size(handles.data_t.rows));
            end
        else
            aux=handles;
            if size(temp.data_t.data,2)>size(handles.data_t.data,2)
                handles.data_t=temp.data_t;
                handles.data_t.data=[handles.data_t.data zeros(size(handles.data_t.data,1),size(temp.data_t.data,2)-size(handles.data_t.data,2))];
            elseif size(temp.data_t.data,2)<size(handles.data_t.data,2)
                temp.data_t.data=[temp.data_t.data zeros(size(temp.data_t.data,1),size(handles.data_t.data,2)-size(temp.data_t.data,2))];
            end
            if size(temp.cr_input.data,2)>size(handles.cr_input.data,2)
                handles.cr_input=temp.cr_input;
                handles.cr_input.data=[handles.cr_input.data zeros(size(handles.cr_input.data,1),size(temp.cr_input.data,2)-size(handles.cr_input.data,2))];
            elseif size(temp.cr_input.data,2)<size(handles.cr_input.data,2)
                temp.cr_input.data=[temp.cr_input.data zeros(size(temp.cr_input.data,1),size(handles.cr_input.data,2)-size(temp.cr_input.data,2))];
            end
%             if size(temp.static_stadistics.data,2)>size(handles.static_stadistics.data,2)
%                 handles.static_stadistics=temp.static_stadistics;
%                 handles.static_stadistics.data=[handles.static_stadistics.data zeros(size(handles.static_stadistics.data,1),size(temp.static_stadistics.data,2)-size(handles.static_stadistics.data,2))];
%             elseif size(temp.static_stadistics.data,2)<size(handles.static_stadistics.data,2)
%                 temp.static_stadistics.data=[temp.static_stadistics.data zeros(size(temp.static_stadistics.data,1),size(handles.static_stadistics.data,2)-size(temp.static_stadistics.data,2))];
%             end
            temp.data_t.data(:,temp.data_t.iIndex)=[max(aux.data_t.data(:,aux.data_t.iIndex))+1:max(aux.data_t.data(:,aux.data_t.iIndex))+size(temp.data_t.data,1)].';
%             temp.static_stadistics.data(:,temp.static_stadistics.iIndex)=temp.data_t.data(:,temp.data_t.iIndex);
            temp.cr_input.data(:,1)=temp.data_t.data(:,temp.data_t.iIndex);
            handles.data_t.rows={aux.data_t.rows{:} temp.data_t.rows{:}};
            if ~isfield(handles.data_t,'relevant_data')
                aux.data_t.relevant_data=cell(size(aux.data_t.rows));
            end
            if ~isfield(temp.data_t,'relevant_data')
                temp.data_t.relevant_data=cell(size(temp.data_t.rows));
            end
            if iscell(aux.data_t.relevant_data)&&iscell(temp.data_t.relevant_data)
                handles.data_t.relevant_data={aux.data_t.relevant_data{:} temp.data_t.relevant_data{:}};
            end
            
            handles.data_t.data=[aux.data_t.data;temp.data_t.data];
            if size(aux.data_t.data,2)<size(temp.data_t.data)
                aux.cr_input.data=[aux.cr_input.data,zeros(size(aux.cr_input.data,1),1)];
            elseif size(aux.data_t.data,2)>size(temp.data_t.data)
                temp.cr_input.data=[temp.cr_input.data,zeros(size(temp.cr_input.data,1),1)];
            end
            handles.cr_input.data=[aux.cr_input.data;temp.cr_input.data];
            handles.cr_input.threshold={aux.cr_input.threshold{:} temp.cr_input.threshold{:}};
%             handles.static_stadistics.data=[aux.static_stadistics.data;temp.static_stadistics.data];
        end
        handles.static_stadistics=static_metrics_stadistics(handles.data_t,handles.cr_input);
        guidata(hObject,handles);
        menutable_Callback(hObject, eventdata, handles);
    else
        'Invalid File'    
    end
    
end



% --- Executes on selection change in searchoptions.
function searchoptions_Callback(hObject, eventdata, handles)
% hObject    handle to searchoptions (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns searchoptions contents as cell array
%        contents{get(hObject,'Value')} returns selected item from searchoptions
if get(hObject,'value')==1
    set(handles.enearestpeaks,'enable','on');
    set(handles.eiterations,'enable','on');
    set(handles.efake,'enable','on');
    for i=1:5
        eval(['set(handles.emetrics',num2str(i),',',char(39),'enable',char(39),',',char(39),'on',char(39),');'])
        eval(['set(handles.esorting',num2str(i),',',char(39),'enable',char(39),',',char(39),'on',char(39),');'])
        eval(['set(handles.emin_factor',num2str(i),',',char(39),'enable',char(39),',',char(39),'on',char(39),');'])
        eval(['set(handles.ethreshold',num2str(i),',',char(39),'enable',char(39),',',char(39),'on',char(39),');'])
    end
elseif get(hObject,'value')==2
    set(handles.efake,'string','0');
    set(handles.eiterations,'string','1');
    set(handles.eiterations,'enable','inactive');
    set(handles.efake,'enable','inactive');
    set(handles.enearestpeaks,'enable','inactive');
    for i=1:5
        eval(['set(handles.esorting',num2str(i),',',char(39),'enable',char(39),',',char(39),'inactive',char(39),');'])
        eval(['set(handles.emin_factor',num2str(i),',',char(39),'enable',char(39),',',char(39),'inactive',char(39),');'])
        eval(['set(handles.ethreshold',num2str(i),',',char(39),'enable',char(39),',',char(39),'inactive',char(39),');'])
    end
end

% --- Executes during object creation, after setting all properties.
function searchoptions_CreateFcn(hObject, eventdata, handles)
% hObject    handle to searchoptions (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% 
% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in menutable.
function menutable_Callback(hObject, eventdata, handles)
% hObject    handle to menutable (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns menutable contents as cell array
%        contents{get(hObject,'Value')} returns selected item from menutable



if isstruct(handles.data_t)
    
    if ~ishandle(handles.results_table);
        handles.results_table=Results_table();
        guidata(hObject,handles);
        handles=guidata(hObject);
    end
    rhandles=guidata(handles.results_table); 
    contents=get(handles.menutable,'Value');
    if contents==1
        set(rhandles.eresultstable,'ColumnName',transformtitle({handles.data_t.columns{:,1+get(handles.hindexes,'Value'):size(handles.data_t.data,2)}}));
        set(rhandles.eresultstable,'RowName',handles.data_t.rows);
        set(rhandles.eresultstable,'Data',handles.data_t.data(:,1+get(handles.hindexes,'Value'):size(handles.data_t.data,2)));
    elseif contents==2
        handles.static_stadistics=static_metrics_stadistics(handles.data_t,handles.cr_input);
        guidata(hObject,handles);
        set(rhandles.eresultstable,'ColumnName',transformtitle({handles.static_stadistics.columns{:,1+get(handles.hindexes,'Value'):size(handles.static_stadistics.data,2)}}));
        set(rhandles.eresultstable,'RowName',handles.data_t.rows);
        set(rhandles.eresultstable,'Data',handles.static_stadistics.data(:,1+get(handles.hindexes,'Value'):size(handles.static_stadistics.data,2)));
    elseif contents==3
        set(rhandles.eresultstable,'ColumnName',transformtitle({handles.cr_input.columns{:,1+get(handles.hindexes,'Value'):size(handles.cr_input.data,2)}}));
        set(rhandles.eresultstable,'RowName',handles.data_t.rows);
        set(rhandles.eresultstable,'Data',handles.cr_input.data(:,1+get(handles.hindexes,'Value'):size(handles.cr_input.data,2)));
    elseif contents==4
        set(rhandles.eresultstable,'ColumnName',transformtitle(handles.searching.c_label));
        set(rhandles.eresultstable,'RowName',handles.searching.r_label);
        set(rhandles.eresultstable,'Data',handles.searching.data_strehl);
    elseif contents==5
        set(rhandles.eresultstable,'ColumnName',transformtitle(handles.searching.c_label));
        set(rhandles.eresultstable,'RowName',handles.searching.r_label);
        set(rhandles.eresultstable,'Data',handles.searching.data_HE);
    elseif contents==6
        set(rhandles.eresultstable,'ColumnName',transformtitle(handles.searching.c_label));
        set(rhandles.eresultstable,'RowName',handles.searching.r_label);
        set(rhandles.eresultstable,'Data',handles.searching.data_CPotency);
    end
    
    set(handles.rxaxis,'String',{handles.data_t.columns{:,:},handles.static_stadistics.columns{:,2:length(handles.static_stadistics.columns)},handles.cr_input.columns{:,2:length(handles.cr_input.columns)}});
    set(handles.ryaxis,'String',{handles.data_t.columns{:,:},handles.static_stadistics.columns{:,2:length(handles.static_stadistics.columns)},handles.cr_input.columns{:,2:length(handles.cr_input.columns)},'CDF','Histogram'});
    
    pos=get(rhandles.figure1,'Position');
    t_size=get(rhandles.eresultstable,'Extent');
    if t_size(3)>315&&pos(3)<357
        t_size(3)=350;
        t_size(4)=t_size(4)+1;
    end
    
    if t_size(4)>50&&pos(4)<55
        t_size(4)=50;
        t_size(3)=t_size(3)+3;
    end
    t_size(3)=(t_size(3)+2.5);
    t_size(4)=(max(t_size(4),3)+2);
    
    t_size(2)=pos(2)+pos(4)-t_size(4);
    t_size(1)=max(round(pos(1)+pos(3)/2)-t_size(3)/2,0);
    
    set(rhandles.figure1,'Position',t_size);
    set(handles.results_table,'Visible','on');
    
end


% --- Executes on button press in bplot.
function bplot_Callback(hObject, eventdata, handles)

% hObject    handle to bplot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
order=min(str2num(get(handles.asdef,'String')),10);
if ~strcmp(get(handles.rxaxis,'String'),' ')
    
    ix=get(handles.rxaxis,'Value');
    iy=get(handles.ryaxis,'Value');
    if (ix<=length(handles.data_t.columns))
        x_axis=handles.data_t.data(:,ix);
        x_title=handles.data_t.columns{ix};
    elseif((ix-length(handles.data_t.columns)+1)<=length(handles.static_stadistics.columns))
        x_axis=handles.static_stadistics.data(:,(ix-length(handles.data_t.columns)+1));
        x_title=handles.static_stadistics.columns{(ix-length(handles.data_t.columns)+1)};
    elseif((ix-length(handles.data_t.columns)-length(handles.static_stadistics.columns)+2)<=length(handles.cr_input.columns))
        x_axis=handles.cr_input.data(:,(ix-length(handles.data_t.columns)-length(handles.static_stadistics.columns)+2));
        x_title=handles.cr_input.columns{(ix-length(handles.data_t.columns)-length(handles.static_stadistics.columns)+2)};
    end
    if (iy<=length(handles.data_t.columns))
        y_axis=handles.data_t.data(:,iy);
        y_title=handles.data_t.columns{iy};
    elseif((iy-length(handles.data_t.columns)+1)<=length(handles.static_stadistics.columns))
        y_axis=handles.static_stadistics.data(:,(iy-length(handles.data_t.columns)+1));
        y_title=handles.static_stadistics.columns{(iy-length(handles.data_t.columns)+1)};
    elseif((iy-length(handles.data_t.columns)-length(handles.static_stadistics.columns)+2)<=length(handles.cr_input.columns))
        y_axis=handles.cr_input.data(:,(iy-length(handles.data_t.columns)-length(handles.static_stadistics.columns)+2));
        y_title=handles.cr_input.columns{(iy-length(handles.data_t.columns)-length(handles.static_stadistics.columns)+2)};
    else
        iy=iy-length(handles.data_t.columns)-length(handles.static_stadistics.columns)-length(handles.cr_input.columns)+2;
        y_axis=[1:size(x_axis,1)]';
        if iy==1
            y_title='CDF';
        elseif iy==2
            y_title='Histogram';
        end
    end
    if((sum(handles.cr_input.data(:,handles.cr_input.ifake_metric)==1)>0)&&(sum(handles.cr_input.data(:,handles.cr_input.ifake_metric)==3)>0)&&(sum(handles.cr_input.data(:,handles.cr_input.ifake_metric)==0)>0))
        disp('Multiplot...');
        multiplot=1;
    else
        multiplot=0;
    end

    if strcmp(x_title,'base_field')%&&(max(handles.cr_input.data(:,handles.cr_input.iiterations))>1)
        if get(handles.efit,'Value')
            lin='-';
        else
            lin='';
        end
        maxi=max(handles.cr_input.data(:,handles.cr_input.iiterations));
        
        ap=1;
        aps=handles.cr_input.data(:,handles.cr_input.iapdiameter_meter);
        while (sum(aps~=0))
            ap_values(ap)=max(aps);
            aps(aps==ap_values(ap))=0;
            ap=ap+1;
        end
        ia=1;
        iang=handles.cr_input.data(:,handles.cr_input.iiangle);
        while (sum(iang~=0))
            ia_values(ia)=max(iang);
            iang(iang==ia_values(ia))=0;
            ia=ia+1;
        end
        pos=[1600,0,1650/length(ia_values),1200/length(ap_values)];
        
        for ap=1:length(ap_values)
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Creating separated archives %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
%    PathName='D:\muno_ma\Matlab\fields\';
%    temp.data_t=handles.data_t;
%    temp.static_stadistics=handles.static_stadistics;
%    temp.cr_input=handles.cr_input;
%     
%    temp.data_t.rows=handles.data_t.rows((handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)));
%    temp.data_t.relevant_data=handles.data_t.relevant_data((handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)));
%    temp.data_t.data=handles.data_t.data((handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)),:);
%    temp.static_stadistics.data=handles.static_stadistics.data((handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)),:);
%    temp.cr_input.data=handles.cr_input.data((handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)),:);
%    APHEFIS_DATA=temp;
%    FileName=['10_20_30degrees_1000fields_' num2str(max(handles.cr_input.data(:,handles.cr_input.iiterations))) 'iterations_' num2str(ap_values(ap)) 'm_aperture_FM1_Sthreshold0.55numpeaks10_anulating_error_function.aph'];
%    save([PathName,FileName],'APHEFIS_DATA');  
%             
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            for ia=1:length(ia_values)
                
                figure('Name',['Aperture ' num2str(ap_values(ap)) 'm, Incidence Angle ' num2str(ia_values(ia)) ' degrees'],'Position',[pos(1)+(ia-1)*pos(3),pos(2)+(ap-1)*pos(4),pos(3),pos(4)-5]);
                hold on;
                title(['Aperture ' num2str(ap_values(ap)) 'm, Incidence Angle ' num2str(ia_values(ia)) ' degrees'])
                xlabel(transformtitle({x_title}));
                ylabel(transformtitle({y_title}));
        x1=x_axis(((handles.cr_input.data(:,handles.cr_input.iiterations)==1).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
        y1=y_axis(((handles.cr_input.data(:,handles.cr_input.iiterations)==1).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);                
                
        if maxi>2||multiplot
            if multiplot
                x_axis_=x1;
                y_axis_=y1;
                x1=x_axis_(((handles.cr_input.data(:,handles.cr_input.ifake_metric)==3).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                x2=x_axis_(((handles.cr_input.data(:,handles.cr_input.ifake_metric)==1).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                x3=x_axis_(((handles.cr_input.data(:,handles.cr_input.ifake_metric)==0).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                
                x4=x_axis_(((handles.cr_input.data(:,handles.cr_input.ifake_metric)==0).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                y1=y_axis_(((handles.cr_input.data(:,handles.cr_input.ifake_metric)==3).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                y2=y_axis_(((handles.cr_input.data(:,handles.cr_input.ifake_metric)==1).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                y3=y_axis_(((handles.cr_input.data(:,handles.cr_input.ifake_metric)==0).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                y4=y_axis_(((handles.cr_input.data(:,handles.cr_input.ifake_metric)==0).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                if (sum(handles.cr_input.data(:,handles.cr_input.ifake_metric)==4)>0)
                    x5=x_axis_(((handles.cr_input.data(:,handles.cr_input.ifake_metric)==4).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                    y5=y_axis_(((handles.cr_input.data(:,handles.cr_input.ifake_metric)==4).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                end
            else
                x2=x_axis(((handles.cr_input.data(:,handles.cr_input.iiterations)==round(maxi/2)).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                y2=y_axis(((handles.cr_input.data(:,handles.cr_input.iiterations)==round(maxi/2)).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                x3=x_axis(((handles.cr_input.data(:,handles.cr_input.iiterations)==maxi).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                y3=y_axis(((handles.cr_input.data(:,handles.cr_input.iiterations)==maxi).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
            end
            if strcmp(y_title,'TotalP')
                y2=y2./y1;
                y3=y3./y1;
                y1=ones(size(y1,1),size(y1,2));
                lin='-';
            elseif strcmp(y_title,'CDF')
                x1=sort(x1);
                y1=[1:size(x1,1)]/size(x1,1);
                x2=sort(x2);
                y2=[1:size(x2,1)]/size(x2,1);
                x3=sort(x3);
                y3=[1:size(x3,1)]/size(x3,1);
                lin='-';
                if multiplot
                    x4=sort(x4);
                    y4=[1:size(x4,1)]/size(x4,1);
                    if exist('x5','var')
                        x5=sort(x5);
                        y5=[1:size(x5,1)]/size(x5,1);
                    end
                end
            elseif strcmp(y_title,'Histogram')
                x1=sort(x1);
                x2=sort(x2);
                x3=sort(x3);
                [y1,x1]=hist(x1);
                [y2,x2]=hist(x2);
                [y3,x3]=hist(x3);
                if multiplot
                    [y4,x4]=hist(x4);
                    if exist('x5','var')
                        [y5,x5]=hist(x5);
                    end
                end
            end
            plot(x1,y1,[lin 'dr'],'MarkerSize',3,'MarkerFaceColor','r');
            if multiplot
                plot(x4,y4,[lin 'db'],'MarkerSize',3,'MarkerFaceColor','k');
                if exist('x5','var')
                    plot(x5,y5,[lin 'db'],'MarkerSize',3,'MarkerFaceColor','b');
                end
            end
            plot(x2,y2,[lin 'db'],'MarkerSize',3,'MarkerFaceColor','y');
            plot(x3,y3,[lin 'dg'],'MarkerSize',3,'MarkerFaceColor','g');
            if multiplot
                if exist('x5','var')
                    legend('Leveled Known Phase','Original','With Segmented Regions','Only High Power Regions','Predicted Phase');
                else
                    legend('Leveled Known Phase','Original','Only High Power Zones','Predicted Phase');
                end
            else
                legend('Iteration 1',['Iteration ',num2str(round(maxi/2))],['Iteration ',num2str(maxi)]);
            end
        elseif maxi>1||strcmp(y_title,'OutStrehl')||strcmp(y_title,'OutHE')
            if maxi>1
                x2=x_axis(((handles.cr_input.data(:,handles.cr_input.iiterations)==maxi).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                y2=y_axis(((handles.cr_input.data(:,handles.cr_input.iiterations)==maxi).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
            elseif strcmp(y_title,'OutStrehl')||strcmp(y_title,'OutHE')
                y_axis=handles.data_t.data(:,iy-1);
                y2=y_axis(((handles.cr_input.data(:,handles.cr_input.iiterations)==maxi).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                x2=x1;
            end
            if strcmp(y_title,'CDF')
                x1=sort(x1);
                y1=[1:size(x1,1)]/size(x3,1);
                lin='-';
                 x2=sort(x2);
                 y2=[1:size(x2,1)]/size(x2,1);
            elseif strcmp(y_title,'Histogram')
                x1=sort(x1);
                x2=sort(x2);
                [y1,x1]=hist(x1);
                [y2,x2]=hist(x2);
            end
            plot(x1,y1,[lin 'dr'],'MarkerSize',3,'MarkerFaceColor','r');
            plot(x2,y2,[lin 'db'],'MarkerSize',3,'MarkerFaceColor','b');
            if((sum(handles.cr_input.data(:,handles.cr_input.iiterations)==1)>0)&&(sum(handles.cr_input.data(:,handles.cr_input.iiterations)==1)>0)&&(sum(handles.cr_input.data(:,handles.cr_input.iiterations)==2)>0)&&(sum(handles.cr_input.data(:,handles.cr_input.iiterations)==0)>0))
                
            end
            legend('Iteration 1',['Iteration ',num2str(maxi+maxi==1)]);
        else
            if strcmp(y_title,'CDF')
                x1=sort(x1);
                y1=[1:size(x1,1)]/size(x3,1);
                lin='-';
            elseif strcmp(y_title,'Histogram')
                x1=sort(x1);
                [y1,x1]=hist(x1);
            end
            plot(x1,y1,[lin 'dr'],'MarkerSize',3,'MarkerFaceColor','r');
        end

            end
        end
    elseif strcmp(x_title,'iterations')&&~strcmp(y_title,'CDF')
        ap=1;
        aps=handles.cr_input.data(:,handles.cr_input.iapdiameter_meter);
        while (sum(aps~=0))
            ap_values(ap)=max(aps);
            aps(aps==ap_values(ap))=0;
            ap=ap+1;
        end
        ia=1;
        iang=handles.cr_input.data(:,handles.cr_input.iiangle);
        while (sum(iang~=0))
            ia_values(ia)=max(iang);
            iang(iang==ia_values(ia))=0;
            ia=ia+1;
        end
        pos=[1600,0,1650/length(ia_values),1200/length(ap_values)];

        for ap=1:length(ap_values)
            
            for ia=1:length(ia_values)
                
                x_axis_it=x_axis(((handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                y_axis_it=y_axis(((handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                leg={};
                j=1;
                k=1;
                leg={};
                figure('Name',['Aperture ' num2str(ap_values(ap)) 'm, Incidence Angle ' num2str(ia_values(ia)) ' degrees'],'Position',[pos(1)+(ia-1)*pos(3),pos(2)+(ap-1)*pos(4),pos(3),pos(4)-5]);
                hold on;
                
                
                cmap = hsv(size(x_axis_it,1));
        
                while j<=size(x_axis_it,1)
                    i=1;
                    leg{k}=['Field ',num2str(handles.cr_input.data(j,handles.cr_input.ibase_field))];
                    k=k+1;
                    while (j<=size(x_axis_it,1))&&(x_axis_it(j)==i)
                        i=i+1;
                        j=j+1;
                    end
                    order=str2num(get(handles.eorderfit,'String'));
                    if strcmp(y_title,'TotalP')
                        y_axis_it(j-i+1:j-1)=y_axis_it(j-i+1:j-1)/y_axis_it(j-i+1);
                    end
                    if get(handles.efit,'Value')&&order~=0%&&~get(handles.efitmean,'Value')
                        aux=[min(x_axis_it(j-i+1:j-1)):max(x_axis_it(j-i+1:j-1))].';
                        inputs=ones(size(aux,1),abs(order)+1+(order>1)*2);
                        x_in=zeros(size(x_axis_it(j-i+1:j-1),1),abs(order)+2*(order>1));
                        x_in(:,1)=x_axis_it(j-i+1:j-1);
                        for l=1:order
                            x_in(:,abs(l))=x_axis_it(j-i+1:j-1).^l;
                            inputs(:,abs(l)+1)=aux.^l;
                        end
                        if order>1
                            x_in(:,order+1)=1./x_axis_it(j-i+1:j-1);
                            inputs(:,order+2)=1./aux;
                            x_in(:,order+2)=x_axis_it(j-i+1:j-1).^0.5;
                            inputs(:,order+3)=aux.^0.5;
                        end
                        [thetas,mu,sigma]=lineal_aproximation(x_in,y_axis_it(j-i+1:j-1),1);
                        mu=ones(size(inputs,1),1)*[0 mu];
                        sigma=ones(size(inputs,1),1)*[1 sigma];
                        line=(inputs-mu)./sigma*thetas;
                        leg{k}=' ';
                        k=k+1;
                        plot(aux,line,'-','Color',cmap(j-1,:));
                        plot(x_axis_it(j-i+1:j-1),y_axis_it(j-i+1:j-1),'d','MarkerSize',2,'Color',cmap(j-1,:),'MarkerFaceColor',cmap(j-1,:));
                    elseif get(handles.efit,'Value')&&order~=0
                        leg{k}=' ';
                        plot(x_axis_it(j-i+1:j-1),y_axis_it(j-i+1:j-1),'d','MarkerSize',2,'Color',cmap(j-1,:),'MarkerFaceColor',cmap(j-1,:));
                    else
                        plot(x_axis_it(j-i+1:j-1),y_axis_it(j-i+1:j-1),'-d','MarkerSize',2,'Color',cmap(j-1,:),'MarkerFaceColor',cmap(j-1,:));
                    end
                end
                if get(handles.efit,'Value')&&order~=0&&get(handles.efitmean,'Value')
                        aux=[min(x_axis_it):max(x_axis_it)].';
                        inputs=ones(size(aux,1),abs(order)+1+(order>1)*2);
                        x_in=zeros(size(x_axis_it,1),abs(order)+(order>1)*2);
                        x_in(:,1)=x_axis_it;
                        for l=1:order
                            x_in(:,abs(l))=x_axis_it.^l;
                            inputs(:,abs(l)+1)=aux.^l;
                        end
                        if order>1
                            x_in(:,order+1)=1./x_axis_it;
                            inputs(:,order+2)=1./aux;
                            x_in(:,order+2)=x_axis_it.^0.5;
                            inputs(:,order+3)=aux.^0.5;
                        end
                        [thetas,mu,sigma]=lineal_aproximation(x_in,y_axis_it,1);
                        mu1=ones(size(inputs,1),1)*[0 mu];
                        sigma1=ones(size(inputs,1),1)*[1 sigma];
                        line=(inputs-mu1)./sigma1*thetas;
                        plot(aux,line,'-','Color',[0,0,0],'LineWidth',3);
                        % Curve representation
                        text=num2str(thetas(1)-mu./sigma*thetas(2:size(thetas,1),1));
                        for i=2:size(thetas,1)
                            if thetas(i)/sigma(i-1)>0
                                text=[text '+'];
                            end
                            if i<=abs(order)+1
                                text=[text num2str(thetas(i)/sigma(i-1)) 'X^' num2str(i-1)];
                            elseif i==abs(order)+2
                                text=[text num2str(thetas(i)/sigma(i-1)) 'X^' '-1'];
                            elseif i==abs(order)+3
                                text=[text num2str(thetas(i)/sigma(i-1)) 'X^' '0.5'];
                            end
                        end
                        leg{k}='Mean Line';
                        set(handles.ecurveexp,'String',text);
                end
                if k<10
                    legend(leg);
                end
            end
        end
    elseif strcmp(x_title,'r0_diameter')||strcmp(x_title,'apdiameter_meter')

        lin='';

        maxi=1;

        figure('Position',[0,0,1650,1200]);
        hold on;
        xlabel(transformtitle({x_title}));
        ylabel(transformtitle({y_title}));

        x1=x_axis;
        y1=y_axis;                
        
            if strcmp(y_title,'CDF')
                lin='-';
                x1=sort(x1);
                y1=[1:size(x1,1)]/size(x1,1);
            elseif strcmp(y_title,'Histogram')
                lin='-';
                x1=sort(x1);
                [y1,x1]=hist(x1);
            end
            plot(x1,y1,[lin 'dr'],'MarkerSize',3,'MarkerFaceColor','r');
            

%         figure;
%         hold on
        order=str2num(get(handles.eorderfit,'String'));
        if get(handles.efit,'Value')&&order~=0&&~strcmp(y_title,'CDF')
                x_axis(x_axis<0.0001)=0.0001;
                aux=[min(x_axis):(max(x_axis)-min(x_axis))/size(x_axis,1):max(x_axis)].';
                aux(aux<0.0001)=0.0001;
                
                inputs=ones(size(aux,1),abs(order)+1+(order>1)*2);
                x_in=zeros(size(x_axis,1),abs(order)+(order>1)*2);
                x_in(:,1)=x_axis;
                for k=1:order
                    x_in(:,abs(k))=x_axis.^k;
                    inputs(:,abs(k)+1)=aux.^k;
                end
                if order>1
                    x_in(:,order+1)=1./x_axis;
                    inputs(:,order+2)=1./aux;
                    x_in(:,order+2)=x_axis.^0.5;
                    inputs(:,order+3)=aux.^0.5;
                end
                [thetas,mu0,sigma0]=lineal_aproximation(x_in,y_axis,1);
                mu=ones(size(inputs,1),1)*[0 mu0];
                sigma=ones(size(inputs,1),1)*[1 sigma0]; 
                line=(inputs-mu)./sigma*thetas;
                plot(aux,line,'-','Color',[0,0,0],'LineWidth',3);
                text=num2str(thetas(1)-mu0./sigma0*thetas(2:size(thetas,1),1));
                for i=2:size(thetas,1)
                    if thetas(i)/sigma(i-1)>0
                        text=[text '+'];
                    end
                    if i<=abs(order)+1
                        text=[text num2str(thetas(i)/sigma(i-1)) 'X^' num2str(i-1)];
                    elseif i==abs(order)+2
                        text=[text num2str(thetas(i)/sigma(i-1)) 'X^' '-1'];
                    elseif i==abs(order)+3
                        text=[text num2str(thetas(i)/sigma(i-1)) 'X^' '0.5'];
                    end
                end
                set(handles.ecurveexp,'String',text);
        end


        
    else
        
        
        if strcmp(y_title,'CDF')
            lin='-';
        else
            lin='';
        end
        maxi=max(handles.cr_input.data(:,handles.cr_input.iiterations));
        
        ap=1;
        aps=handles.cr_input.data(:,handles.cr_input.iapdiameter_meter);
        while (sum(aps~=0))
            ap_values(ap)=max(aps);
            aps(aps==ap_values(ap))=0;
            ap=ap+1;
        end
        ia=1;
        iang=handles.cr_input.data(:,handles.cr_input.iiangle);
        while (sum(iang~=0))
            ia_values(ia)=max(iang);
            iang(iang==ia_values(ia))=0;
            ia=ia+1;
        end
        pos=[0,0,1650/length(ia_values),1200/length(ap_values)];
        if multiplot &&(strcmp(y_title,'OutStrehl')||strcmp(y_title,'OutHE')||strcmp(x_title,'OutStrehl')||strcmp(x_title,'OutHE'))
            m=1;
            if ix>1
                x_axis2=handles.data_t.data(:,ix-1);
            else
                x_axis2=handles.data_t.data(:,ix-1);
            end
            if iy>1
                y_axis2=handles.data_t.data(:,iy-1);
            else
                y_axis2=handles.data_t.data(:,iy);
            end
        else
            m=0;
        end
        
        for ap=1:length(ap_values)
            for ia=1:length(ia_values)
                
                figure('Name',['Aperture ' num2str(ap_values(ap)) 'm, Incidence Angle ' num2str(ia_values(ia)) ' degrees'],'Position',[pos(1)+(ia-1)*pos(3),pos(2)+(ap-1)*pos(4),pos(3),pos(4)-5]);
%                 figure('Position',[pos(1),pos(2),pos(3),pos(4)-5]);
                
                hold on;
                title(['Aperture ' num2str(ap_values(ap)) 'm, Incidence Angle ' num2str(ia_values(ia)) ' degrees'])
                xlabel(transformtitle({x_title}));
                ylabel(transformtitle({y_title}));

        x1=x_axis(((handles.cr_input.data(:,handles.cr_input.iiterations)==1).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
        y1=y_axis(((handles.cr_input.data(:,handles.cr_input.iiterations)==1).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);                
                
        if maxi>2||multiplot
            if multiplot
%                 if m
%                     x4=x_axis2(((handles.cr_input.data(:,handles.cr_input.ifake_metric)==0).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
%                     y4=y_axis2(((handles.cr_input.data(:,handles.cr_input.ifake_metric)==0).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
%                 end
%                 x1=x_axis(((handles.cr_input.data(:,handles.cr_input.ifake_metric)==3).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
%                 x2=x_axis(((handles.cr_input.data(:,handles.cr_input.ifake_metric)==1).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
%                 x3=x_axis(((handles.cr_input.data(:,handles.cr_input.ifake_metric)==0).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
%                 y1=y_axis(((handles.cr_input.data(:,handles.cr_input.ifake_metric)==3).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
%                 y2=y_axis(((handles.cr_input.data(:,handles.cr_input.ifake_metric)==1).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
%                 y3=y_axis(((handles.cr_input.data(:,handles.cr_input.ifake_metric)==0).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
%                 
%                 if (sum(handles.cr_input.data(:,handles.cr_input.ifake_metric)==4)>0)
%                     x5=x_axis(((handles.cr_input.data(:,handles.cr_input.ifake_metric)==4).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
%                     y5=y_axis(((handles.cr_input.data(:,handles.cr_input.ifake_metric)==4).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
%                 end 
%                 
                if m
                    x4=x_axis2(handles.cr_input.data(:,handles.cr_input.ifake_metric)==0);
                    y4=y_axis2(handles.cr_input.data(:,handles.cr_input.ifake_metric)==0);
                end
                x1=x_axis(handles.cr_input.data(:,handles.cr_input.ifake_metric)==3);
                x2=x_axis(handles.cr_input.data(:,handles.cr_input.ifake_metric)==1);
                x3=x_axis(handles.cr_input.data(:,handles.cr_input.ifake_metric)==0);
                y1=y_axis(handles.cr_input.data(:,handles.cr_input.ifake_metric)==3);
                y2=y_axis(handles.cr_input.data(:,handles.cr_input.ifake_metric)==1);
                y3=y_axis(handles.cr_input.data(:,handles.cr_input.ifake_metric)==0);
                
                if (sum(handles.cr_input.data(:,handles.cr_input.ifake_metric)==4)>0)
                    x5=x_axis(handles.cr_input.data(:,handles.cr_input.ifake_metric)==4);
                    y5=y_axis(handles.cr_input.data(:,handles.cr_input.ifake_metric)==4);
                end 
            else
                x2=x_axis(((handles.cr_input.data(:,handles.cr_input.iiterations)==round(maxi/2)).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                y2=y_axis(((handles.cr_input.data(:,handles.cr_input.iiterations)==round(maxi/2)).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                x3=x_axis(((handles.cr_input.data(:,handles.cr_input.iiterations)==maxi).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                y3=y_axis(((handles.cr_input.data(:,handles.cr_input.iiterations)==maxi).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
            end
            if strcmp(y_title,'TotalP')
                y2=y2./y1;
                y3=y3./y1;
                y1=ones(size(y1,1),size(y1,2));
                
            elseif strcmp(y_title,'CDF')
                lin='-';
                x1=sort(x1);
                y1=[1:size(x1,1)]/size(x1,1);
                x2=sort(x2);
                y2=[1:size(x2,1)]/size(x2,1);
                x3=sort(x3);
                y3=[1:size(x3,1)]/size(x3,1);
                if multiplot
                    if m
                        x4=sort(x4);
                        y4=[1:size(x4,1)]/size(x4,1);
                    end
                    if exist('x5','var')
                        x5=sort(x5);
                        y5=[1:size(x5,1)]/size(x5,1);
                    end
                end
            elseif strcmp(y_title,'Histogram')
                lin='-';
                x1=sort(x1);
                x2=sort(x2);
                x3=sort(x3);
                [y1,x1]=hist(x1);
                [y2,x2]=hist(x2);
                [y3,x3]=hist(x3);
                if multiplot
                    if m
                        [y4,x4]=hist(x4);
                    end
                    if exist('x5','var')
                        [y5,x5]=hist(x5);
                    end
                end
            end
            plot(x1,y1,[lin 'dr'],'MarkerSize',3,'MarkerFaceColor','r');
            if multiplot
                if m
                    plot(x4,y4,[lin 'dk'],'MarkerSize',3,'MarkerFaceColor','k');
                end
                if exist('x5','var')
                    plot(x5,y5,[lin 'db'],'MarkerSize',3,'MarkerFaceColor','b');
                end
            end
            plot(x2,y2,[lin 'dy'],'MarkerSize',3,'MarkerFaceColor','y');
            plot(x3,y3,[lin 'dg'],'MarkerSize',3,'MarkerFaceColor','g');
            if multiplot
                if exist('x5','var')
                    if m
                        legend('Leveled Known Phase','Original','With Segmented Regions','Only High Power Regions','Predicted Phase');
                    else
                        legend('Leveled Known Phase','With Segmented Regions','Only High Power Regions','Predicted Phase');
                    end
                else
                    if m
                        legend('Leveled Known Phase','Original','Only High Power Zones','Predicted Phase');
                    else
                        legend('Leveled Known Phase','Only High Power Zones','Predicted Phase');
                    end
                end
            else
                legend('Iteration 1',['Iteration ',num2str(round(maxi/2))],['Iteration ',num2str(maxi)]);
            end
        elseif maxi>1||strcmp(y_title,'OutStrehl')||strcmp(y_title,'OutHE')||strcmp(x_title,'OutStrehl')||strcmp(x_title,'OutHE')
            if maxi>1
                x2=x_axis(((handles.cr_input.data(:,handles.cr_input.iiterations)==maxi).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                y2=y_axis(((handles.cr_input.data(:,handles.cr_input.iiterations)==maxi).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
            elseif strcmp(y_title,'OutStrehl')||strcmp(y_title,'OutHE')
                y_axis2=handles.data_t.data(:,iy-1);
                y2=y_axis2(((handles.cr_input.data(:,handles.cr_input.iiterations)==maxi).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
                x2=x1;
            elseif strcmp(x_title,'OutStrehl')||strcmp(x_title,'OutHE')
                x_axis2=handles.data_t.data(:,ix-1);
                x2=x_axis2(((handles.cr_input.data(:,handles.cr_input.iiterations)==maxi).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);            
                y2=y_axis(((handles.cr_input.data(:,handles.cr_input.iiterations)==maxi).*(handles.cr_input.data(:,handles.cr_input.iapdiameter_meter)==ap_values(ap)).*(handles.cr_input.data(:,handles.cr_input.iiangle)==ia_values(ia)))>0);
            end
            
            if strcmp(y_title,'CDF')
                lin='-';
                x1=sort(x1);
                y1=[1:size(x1,1)]/size(x1,1);
                x2=sort(x2);
                y2=[1:size(x2,1)]/size(x2,1);
            elseif strcmp(y_title,'Histogram')
                lin='-';
                x1=sort(x1);
                x2=sort(x2);
                [y1,x1]=hist(x1);
                [y2,x2]=hist(x2);
            end
            plot(x1,y1,[lin 'dr'],'MarkerSize',3,'MarkerFaceColor','r');
            plot(x2,y2,[lin 'db'],'MarkerSize',3,'MarkerFaceColor','b');
            if multiplot
                legend('Full Aproximated Phase','Only central zones','With Calculated phases');
            else
                legend('Iteration 1',['Iteration ',num2str(maxi-maxi==1)]);
            end
        else
            if strcmp(y_title,'CDF')
                lin='-';
                x1=sort(x1);
                y1=[1:size(x1,1)]/size(x1,1);
            elseif strcmp(y_title,'Histogram')
                lin='-';
                x1=sort(x1);
                [y1,x1]=hist(x1);
            end
            plot(x1,y1,[lin 'dr'],'MarkerSize',3,'MarkerFaceColor','r');
            legend('Iteration 1');
            
        end

%         figure;
%         hold on
        order=str2num(get(handles.eorderfit,'String'));
        if get(handles.efit,'Value')&&order~=0&&~strcmp(y_title,'CDF')
                x_axis(x_axis<0.0001)=0.0001;
                aux=[min(x_axis):(max(x_axis)-min(x_axis))/size(x_axis,1):max(x_axis)].';
                aux(aux<0.0001)=0.0001;
                
                inputs=ones(size(aux,1),abs(order)+1+(order>1)*2);
                x_in=zeros(size(x_axis,1),abs(order)+(order>1)*2);
                x_in(:,1)=x_axis;
                for k=1:order
                    x_in(:,abs(k))=x_axis.^k;
                    inputs(:,abs(k)+1)=aux.^k;
                end
                if order>1
                    x_in(:,order+1)=1./x_axis;
                    inputs(:,order+2)=1./aux;
                    x_in(:,order+2)=x_axis.^0.5;
                    inputs(:,order+3)=aux.^0.5;
                end
                [thetas,mu0,sigma0]=lineal_aproximation(x_in,y_axis,1);
                mu=ones(size(inputs,1),1)*[0 mu0];
                sigma=ones(size(inputs,1),1)*[1 sigma0]; 
                line=(inputs-mu)./sigma*thetas;
                plot(aux,line,'-','Color',[0,0,0],'LineWidth',3);
                text=num2str(thetas(1)-mu0./sigma0*thetas(2:size(thetas,1),1));
                for i=2:size(thetas,1)
                    if thetas(i)/sigma(i-1)>0
                        text=[text '+'];
                    end
                    if i<=abs(order)+1
                        text=[text num2str(thetas(i)/sigma(i-1)) 'X^' num2str(i-1)];
                    elseif i==abs(order)+2
                        text=[text num2str(thetas(i)/sigma(i-1)) 'X^' '-1'];
                    elseif i==abs(order)+3
                        text=[text num2str(thetas(i)/sigma(i-1)) 'X^' '0.5'];
                    end
                end
                set(handles.ecurveexp,'String',text);
        end


            end
        end
    end
%     grid on;
%     set(gca,'GridLineStyle',':');
    xlabel(transformtitle({x_title}));
    ylabel(transformtitle({y_title}));
    hold off
end

% --- Executes on button press in image.
function image_Callback(hObject, eventdata, handles)
% hObject    handle to image (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if isstruct(handles.cr_input)
index=get(handles.eim_index,'String');
index=eval(['[',index,']']);
index=index(index<=size(handles.cr_input.data,1));

for i=1:size(index,2)
    
    if handles.cr_input.data(index(i),handles.cr_input.imetric)~=0
        if handles.cr_input.data(index(i),handles.cr_input.ifake_metric)~=0;
            nocheat=0;
        else
            nocheat=1;
        end
    
        [~,~,~,~,~,~,err,mess]=start_APHEFIS(handles.cr_input.data(index(i),handles.cr_input.inum_levels),handles.cr_input.data(index(i),handles.cr_input.inearestpeaks),handles.cr_input.data(index(i),handles.cr_input.inum_peaks),str2num(get(handles.ezoomfa,'String')),...
            0,1,0,handles.cr_input.data(index(i),handles.cr_input.iz_coefs),handles.cr_input.data(index(i),handles.cr_input.imin_factor),handles.cr_input.data(index(i),handles.cr_input.ipixel_focalfield),...
            handles.cr_input.data(index(i),handles.cr_input.iapdiameter_meter), handles.cr_input.data(index(i),handles.cr_input.ilambda),handles.cr_input.data(index(i),handles.cr_input.ifieldsize_m),handles.cr_input.data(index(i),handles.cr_input.iiterations),1,...
            handles.cr_input.data(index(i),handles.cr_input.iiangle),handles.cr_input.data(index(i),handles.cr_input.ibase_field),handles.cr_input.data(index(i),handles.cr_input.imetric),...
            handles.cr_input.data(index(i),handles.cr_input.ifake_metric),handles.cr_input.data(index(i),handles.cr_input.isubstract_maximum_phase),{handles.cr_input.threshold{:,index(i)}},0);
        if size(err)>0
            mess
        end
    else
        if handles.cr_input.data(index(i),handles.cr_input.ifake_metric)~=0
            param=0;
        else
            param=handles.param;
        end
        if isfield(handles.data_t,'Zern_in')&&get(handles.ezernuse,'Value')
            auxzern.ain={handles.data_t.Zern_in{index(i)}};
            auxzern.rmsi={handles.data_t.rms_in(index(i))};
            auxzern.aout={handles.data_t.Zern_out{index(i)}};
            auxzern.rmso={handles.data_t.rms_out(index(i))};
        else
            auxzern=handles.cr_input.data(index(i),handles.cr_input.iz_coefs);
        end
        [~,~,~,~,~,~]=APHEFIS_bridge(handles.cr_input.data(index(i),handles.cr_input.inum_peaks),str2num(get(handles.ezoomfa,'String')),1,auxzern,0,handles.cr_input.data(index(i),handles.cr_input.ipixel_focalfield),...
            handles.cr_input.data(index(i),handles.cr_input.iapdiameter_meter),handles.cr_input.data(index(i),handles.cr_input.ifieldsize_m),handles.cr_input.data(index(i),handles.cr_input.ilambda),...
            handles.cr_input.data(index(i),handles.cr_input.iiangle),handles.cr_input.data(index(i),handles.cr_input.ibase_field),handles.cr_input.data(index(i),handles.cr_input.iiterations),handles.cr_input.data(index(i),...
            handles.cr_input.ifake_metric)+(handles.cr_input.data(index(i),handles.cr_input.ifake_metric)==0)*str2num(get(handles.efake,'String')),handles.cr_input.data(index(i),handles.cr_input.izernoptions),{param},0);
    end
end
end





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% From here on is an auxiliar button I use %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% for making specific things which don't %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% deserve a button  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% --- Executes on button press in ciclebutton.
function ciclebutton_Callback(hObject, eventdata, handles)
% hObject    handle to ciclebutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.ebase_field,'String','2');
PathName='E:\Matlab\Fields\';



% 
% bestef=0;
% for log2lambda=4:1:7
%     [param2,ccef,text]=optimize_metric(handles.data_t.relevant_data,str2num(get(handles.ehiddenlayers,'String')),2^log2lambda,...
%             str2num(get(handles.elearningiterations,'String')),':',str2num(get(handles.elearningdata,'String')),str2num(get(handles.elearningmodel,'String')),handles.param);
%         if ccef>bestef
%             bestef=ccef;
%             set(handles.elearninglambda,'String',num2str(2^log2lambda));
%             bestlambda=2^log2lambda;
%             handles.param=param2;
%             besttext=text;
%             set(handles.etextmessage,'String',['lambda=' num2str(bestlambda) 13 13 besttext])
%             guidata(hObject,handles);
%             save(['D:\muno_ma\Matlab\params\best_param_lamda' num2str(bestlambda) '.mat'],'param2')
%         end     
% end



%eclear_Callback(hObject, eventdata, handles);
% 
% prev=0;
% 
% for i=2:10
%     
% %    param=optimize_metric(handles.data_t.relevant_data,2,1,1000,num2str(i),0.7,1,prev);
%     FileName=['params_03_04_05_06_07_08_09_1m_20_30_degrees_peak' num2str(i) '_1000it.mat'];
%     aux=load([PathName,FileName],'param');
%     parameter{i-1}=aux.param;
%     
% end
% handles.param=parameter;
% guidata(hObject,handles);


% 
% set(handles.menusimulation,'Value',3);
% start_Callback(hObject, eventdata, handles);
% handles=guidata(hObject);
% FileName=['params_03_04_05_06_07_08_09_1m_10_20_30_degrees_3HL_2000it_0.001lambda.mat'];
% save(['D:\muno_ma\Matlab\params\' FileName ],'param')
% 
% 
% eclear_Callback(hObject, eventdata, handles);
% handles=guidata(hObject);
% 
% 
% set(handles.efake,'String',1);
set(handles.menusimulation,'Value',1);
% set(handles.efast,'Value',0);
% 
% 
% 
% for peaks=10:-10:0
%     
%     disp(['Peaks=' num2str(peaks)])
%     set(handles.enum_peaks,'String',peaks);
%     
% % for ite=1:4:5


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Big bucle %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%







ite=1;
    disp(['Iterations=' num2str(ite)])
    set(handles.eiterations,'String','ite')
% eclear_Callback(hObject, eventdata, handles);
handles=guidata(hObject);
asd=1;
set(handles.eiterations,'String',ite)
for i=1:1
    if i==1
       set(handles.efake,'String',0);
%        set(handles.eiterations,'String',1);
    elseif i==2
        set(handles.efake,'String',1);
%         set(handles.eiterations,'String',5);
    elseif i==3
%         set(handles.eiterations,'String',1);
        set(handles.efake,'String',3);
    elseif i==4
        set(handles.efake,'String',4);
    end

%     eclear_Callback(hObject, eventdata, handles);
    handles=guidata(hObject);




Filenameaps=[];
Filenamefields=[];

for k=0.4:0.2:1
    set(handles.eapdiameter_meter,'String',k);
    disp(['k=' num2str(k)])
    Filenameaps=[Filenameaps '_' num2str(k) ];
for j=1:4
    
    
    
    disp(['j=' num2str(j)])
%     eclear_Callback(hObject, eventdata, handles);
    handles=guidata(hObject);
    if j==1
        set(handles.eiangle,'String',20);
    elseif j==2
        set(handles.eiangle,'String',30);
    elseif j==3
        set(handles.eiangle,'String',10);
    else
        set(handles.eiangle,'String',90);
    end

   start_Callback(hObject, eventdata, handles);
   handles=guidata(hObject);
   
%    handles.data_t.relevant_data=[];
   
   guidata(hObject,handles);
   
   temp.data_t=handles.data_t;
   temp.static_stadistics=handles.static_stadistics;
   temp.cr_input=handles.cr_input;
   APHEFIS_DATA=temp;
   
%    if asd==1;
        Filenamefields=[Filenamefields '_' get(handles.eiangle,'String')];
%    end

%     if ((1-k)<0.001)&&(j==3)
    
        FileName=['10_20_30_90_degrees_' get(handles.enfields,'String') 'fields_' Filenameaps];
   
        a=get(handles.efake,'String');
        if strcmp(a,'0')
            FileName=[FileName 'm_aperture_NN_fast_airy.aph'];
        else
            FileName=[FileName 'm_aperture_FM' a '_threshold0.55_dynamic_num_peaks.aph'];
        end

        save([PathName,'data_to_train.aph'],'APHEFIS_DATA');   
%     end
   
% 
%     
% bestef=0;
% for log2lambda=3:1:7
%     [param2,ccef,text]=optimize_metric(handles.data_t.relevant_data,str2num(get(handles.ehiddenlayers,'String')),2^log2lambda,...
%             str2num(get(handles.elearningiterations,'String')),':',str2num(get(handles.elearningdata,'String')),str2num(get(handles.elearningmodel,'String')),handles.param);
%         if ccef>=bestef
%             bestef=ccef;
%             set(handles.elearninglambda,'String',num2str(2^log2lambda));
%             bestlambda=2^log2lambda;
%             handles.param=param2;
%             besttext=text;
%             set(handles.etextmessage,'String',['lambda=' num2str(bestlambda) 13 13 besttext])
%             guidata(hObject,handles);
%             save(['D:\muno_ma\Matlab\params\best_param_lamda' num2str(bestlambda) '_iangle' get(handles.eiangle,'String') 'aperture_' num2str(k) '.mat'],'param2')
%         end     
% end 
% 
% 
% for log2lambda=bestlambda/2:bestlambda/4:2*bestlambda
%     [param2,ccef,text]=optimize_metric(handles.data_t.relevant_data,str2num(get(handles.ehiddenlayers,'String')),log2lambda,...
%             str2num(get(handles.elearningiterations,'String')),':',str2num(get(handles.elearningdata,'String')),str2num(get(handles.elearningmodel,'String')),handles.param);
%         if ccef>bestef
%             bestef=ccef;
%             set(handles.elearninglambda,'String',num2str(log2lambda));
%             bestlambda=log2lambda;
%             handles.param=param2;
%             besttext=text;
%             set(handles.etextmessage,'String',['lambda=' num2str(bestlambda) 13 13 besttext])
%             guidata(hObject,handles);
%             save(['D:\muno_ma\Matlab\params\best_param_lamda' num2str(bestlambda) '_iangle' get(handles.eiangle,'String') 'aperture_' num2str(k) '.mat'],'param2')
%         end     
% end 
%     
%     
% 
%     eclear_Callback(hObject, eventdata, handles);
%     handles=guidata(hObject);
    
    
    
%    guidata(hObject,handles);
%    handles=guidata(hObject);
   

%    end
   
%    
%    %if asd==1
%         Filename1=[Filename1 get(handles.eiangle,'String') '_']; 
%     end
%    
%     temp=load([PathName,FileName],'-mat');
%     if isfield(temp,'APHEFIS_DATA')&&isfield(temp.APHEFIS_DATA,'data_t')&&isstruct(temp.APHEFIS_DATA.data_t)
%         temp=temp.APHEFIS_DATA;
%         if ~get(handles.eloadadd,'value')||~isstruct(handles.data_t)
%             handles.data_t=temp.data_t;
%             handles.cr_input=temp.cr_input;
%             handles.static_stadistics=temp.static_stadistics;
%             if ~isfield(handles.data_t,'relevant_data')
%                 handles.data_t.relevant_data=cell(size(handles.data_t.rows));
%             end
%         else
%             aux=handles;
%             if size(temp.data_t.data,2)>size(handles.data_t.data,2)
%                 handles.data_t=temp.data_t;
%                 handles.data_t.data=[handles.data_t.data zeros(size(handles.data_t.data,1),size(temp.data_t.data,2)-size(handles.data_t.data,2))];
%             elseif size(temp.data_t.data,2)<size(handles.data_t.data,2)
%                 temp.data_t.data=[temp.data_t.data zeros(size(temp.data_t.data,1),size(handles.data_t.data,2)-size(temp.data_t.data,2))];
%             end
%             if size(temp.cr_input.data,2)>size(handles.cr_input.data,2)
%                 handles.cr_input=temp.cr_input;
%                 handles.cr_input.data=[handles.cr_input.data zeros(size(handles.cr_input.data,1),size(temp.cr_input.data,2)-size(handles.cr_input.data,2))];
%             elseif size(temp.cr_input.data,2)<size(handles.cr_input.data,2)
%                 temp.cr_input.data=[temp.cr_input.data zeros(size(temp.cr_input.data,1),size(handles.cr_input.data,2)-size(temp.cr_input.data,2))];
%             end
%             if size(temp.static_stadistics.data,2)>size(handles.static_stadistics.data,2)
%                 handles.static_stadistics=temp.static_stadistics;
%                 handles.static_stadistics.data=[handles.static_stadistics.data zeros(size(handles.static_stadistics.data,1),size(temp.static_stadistics.data,2)-size(handles.static_stadistics.data,2))];
%             elseif size(temp.static_stadistics.data,2)<size(handles.static_stadistics.data,2)
%                 temp.static_stadistics.data=[temp.static_stadistics.data zeros(size(temp.static_stadistics.data,1),size(handles.static_stadistics.data,2)-size(temp.static_stadistics.data,2))];
%             end
%             temp.data_t.data(:,temp.data_t.iIndex)=[max(aux.data_t.data(:,aux.data_t.iIndex))+1:max(aux.data_t.data(:,aux.data_t.iIndex))+size(temp.data_t.data,1)].';
%             temp.static_stadistics.data(:,temp.static_stadistics.iIndex)=temp.data_t.data(:,temp.data_t.iIndex);
%             temp.cr_input.data(:,1)=temp.data_t.data(:,temp.data_t.iIndex);
%             handles.data_t.rows={aux.data_t.rows{:} temp.data_t.rows{:}};
%             if ~isfield(handles.data_t,'relevant_data')
%                 aux.data_t.relevant_data=cell(size(aux.data_t.rows));
%             end
%             if ~isfield(temp.data_t,'relevant_data')
%                 temp.data_t.relevant_data=cell(size(temp.data_t.rows));
%             end
%             handles.data_t.relevant_data={aux.data_t.relevant_data{:} temp.data_t.relevant_data{:}};
%             handles.data_t.data=[aux.data_t.data;temp.data_t.data];
%             handles.cr_input.data=[aux.cr_input.data;temp.cr_input.data];
%             handles.cr_input.threshold={aux.cr_input.threshold{:} temp.cr_input.threshold{:}};
%             handles.static_stadistics.data=[aux.static_stadistics.data;temp.static_stadistics.data];
%         end
%         guidata(hObject,handles);
%     else
%         'Invalid File'    
%     end
    
end
asd=0;
end
end



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



% end

% 
% instrehl=handles.data_t.data(:,handles.data_t.iInStrehl);  
% outstrehl=handles.data_t.data(:,handles.data_t.iOutStrehl);
% bestStrehl=0;
% inHE=handles.data_t.data(:,handles.data_t.iInHE);  
% outHE=handles.data_t.data(:,handles.data_t.iOutHE);
% bestHE=0;
% m=length(instrehl);
% for th=0:0.01:0.8
%     outaux=outstrehl;
%     outaux(instrehl>th)=instrehl(instrehl>th);
%     tempStrehl=sum(outaux);
%     if tempStrehl>=bestStrehl
%         bestStrehl=tempStrehl;
%         bestThreshold=th;
%         treated_fields=sum(instrehl<=bestThreshold);
%         disp(['Mean Strehl with Threshold ' num2str(th) ' = ' num2str(tempStrehl/m) ', Number of fields treated = ' num2str(treated_fields)]);
%     end
%     outaux=outHE;
%     outaux(inHE>th)=inHE(inHE>th);
%     tempHE=sum(outaux);
%     if tempHE>=bestHE
%         bestHE=tempHE;
%         HEbestThreshold=th;
%         HEtreated_fields=sum(instrehl<=bestThreshold);
%         disp(['Mean HE with Threshold ' num2str(th) ' = ' num2str(tempHE/m) ', Number of fields treated = ' num2str(HEtreated_fields)]);
%     end
% end
% text=[13 'Mean Strehl with Threshold ' num2str(bestThreshold) ' = ' num2str(bestStrehl/m) ', Number of fields treated = ' num2str(treated_fields) ' of ' num2str(length(instrehl)) 13];
% text=[text 'Mean HE with Threshold ' num2str(HEbestThreshold) ' = ' num2str(bestHE/m) ', Number of fields treated = ' num2str(HEtreated_fields) ' of ' num2str(length(instrehl)) 13 13];
% 
% th=0.35;
% outaux=outstrehl;
% outaux(instrehl>th)=instrehl(instrehl>th);
% bestStrehl=sum(outaux);
% handles.data_t.data(:,handles.data_t.iOutStrehl)=outaux;
% worse_Strehl_in=sum(outstrehl<instrehl)/m;
% worse_Strehl_treated=sum(outaux<instrehl)/m;
% 
% outaux(instrehl>th)=inHE(instrehl>th);
% bestHE=sum(outaux);
% treated_fields=sum(instrehl<=th);
% handles.data_t.data(:,handles.data_t.iOutHE)=outaux;
% worse_HE_in=sum(outHE<inHE)/m;
% worse_HE_treated=sum(outaux<inHE)/m;
% 
% 
% text=[text 'Mean Strehl with Threshold ' num2str(bestThreshold) ' = ' num2str(bestStrehl/m) 13];
% text=[text 'Mean HE = ' num2str(bestHE/m) ', Number of fields treated = ' num2str(treated_fields) ' of ' num2str(length(instrehl)) 13 13];
% 
% text=[text 'Fields getting worse in Strehl go from ' num2str(worse_Strehl_in) ' to ' num2str(worse_Strehl_treated) 13];
% text=[text 'Fields getting worse in HE go from ' num2str(worse_HE_in) ' to ' num2str(worse_HE_treated) 13];
% 
% 
% guidata(hObject,handles);
% 
% set(handles.etextmessage,'String',text);

% asd=0;

% end

% 
%    temp.data_t=handles.data_t;
%    temp.static_stadistics=handles.static_stadistics;
%    temp.cr_input=handles.cr_input;
%    APHEFIS_DATA=temp;
% save([PathName,Filename1,Filename2,'m_aperture_NN.aph'],'APHEFIS_DATA');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Taking only the first iteration %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  
%     PathName='D:\muno_ma\Matlab\fields\';
%     temp.data_t=handles.data_t;
%    temp.static_stadistics=handles.static_stadistics;
%    temp.cr_input=handles.cr_input;
%     
%    temp.data_t.rows=handles.data_t.rows((handles.cr_input.data(:,handles.cr_input.iiterations)==1));
%    temp.data_t.relevant_data=handles.data_t.relevant_data((handles.cr_input.data(:,handles.cr_input.iiterations)==1));
%    temp.data_t.data=handles.data_t.data((handles.cr_input.data(:,handles.cr_input.iiterations)==1),:);
%    temp.static_stadistics.data=handles.static_stadistics.data((handles.cr_input.data(:,handles.cr_input.iiterations)==1),:);
%    temp.cr_input.data=handles.cr_input.data((handles.cr_input.data(:,handles.cr_input.iiterations)==1),:);
%    APHEFIS_DATA=temp;
%    FileName=['10_20_30degrees_333fields_' num2str(1) 'iterations_FM1_Sthreshold0.55numpeaks10_anulating_error_function.aph'];
%    save([PathName,FileName],'APHEFIS_DATA');  
            
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% --- Executes on button press in close.
function close_Callback(hObject, eventdata, handles)
% hObject    handle to close (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
figs = get(0, 'Children');
close(figs(figs ~= gcf))

% --- Executes on button press in ekeyboard.
function ekeyboard_Callback(hObject, eventdata, handles)
% hObject    handle to ekeyboard (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
keyboard

% --- Executes on button press in hindexes.
function hindexes_Callback(hObject, eventdata, handles)
% hObject    handle to hindexes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
menutable_Callback(hObject, eventdata, handles)
