function [ mean_v,median_v,std_deviation,text_table,text_d ] = APHEFIS_characteristics( APHEFIS_DATA,s_titles,mean_v,median_v,std_deviation,text_table,text_d,op)

%
%   General function that extracts the main characteristics of a group of
%   fields stored in in_str, and return them in form of text according to
%   "options"
%

sizes=[size(APHEFIS_DATA.data_t.data,2),size(APHEFIS_DATA.static_stadistics.data,2),size(APHEFIS_DATA.cr_input.data,2)];
max_size=max(sizes);

if nargin<8||op==1
    op=1;
    sizes=[size(APHEFIS_DATA.data_t.data,2),size(APHEFIS_DATA.static_stadistics.data,2),size(APHEFIS_DATA.cr_input.data,2)];
    max_size=max(sizes);
    
    mean_v=APHEFIS_DATA;
    mean_v.data_t.data=zeros(s_titles,sizes(1));
    mean_v.static_stadistics.data=zeros(s_titles,sizes(2));
    mean_v.cr_input.data=zeros(s_titles,sizes(3));
    
    median_v=mean_v;
    std_deviation=mean_v;
    text_table=mean_v;
    
    text_table.data_t.data=cell(s_titles,sizes(1));
    text_table.static_stadistics.data=cell(s_titles,sizes(2));
    text_table.cr_input.data=cell(s_titles,sizes(3));
    text_d=cell(1,s_titles);
end


mean_v.data_t.data(op,:)=mean(APHEFIS_DATA.data_t.data);
mean_v.static_stadistics.data(op,:)=mean(APHEFIS_DATA.static_stadistics.data);
mean_v.cr_input.data(op,:)=mean(APHEFIS_DATA.cr_input.data);

median_v.data_t.data(op,:)=median(APHEFIS_DATA.data_t.data);
median_v.static_stadistics.data(op,:)=median(APHEFIS_DATA.static_stadistics.data);
median_v.cr_input.data(op,:)=median(APHEFIS_DATA.cr_input.data);

std_deviation.data_t.data(op,:)=std(APHEFIS_DATA.data_t.data,1);
std_deviation.static_stadistics.data(op,:)=std(APHEFIS_DATA.static_stadistics.data,1);
std_deviation.cr_input.data(op,:)=std(APHEFIS_DATA.cr_input.data,1);

for i=1:max_size
    if i<=sizes(1)
        text_table.data_t.data{op,i}=[num2str(mean_v.data_t.data(op,i),3) ' ' char(177) ' ' num2str(std_deviation.data_t.data(op,i)/mean_v.data_t.data(op,i)*100,3) '%'];
    end
    if i<=sizes(2)
        text_table.static_stadistics.data{op,i}=[num2str(mean_v.static_stadistics.data(op,i),3) ' ' char(177) ' ' num2str(std_deviation.static_stadistics.data(op,i)/mean_v.static_stadistics.data(op,i)*100,3) '%'];
    end
    if i<=sizes(3)
        text_table.cr_input.data{op,i}=[num2str(mean_v.cr_input.data(op,i),3) ' ' char(177) ' ' num2str(std_deviation.cr_input.data(op,i)/mean_v.cr_input.data(op,i)*100,3) '%'];
    end
end

text_d{op}{1}=['\bfFields      :' num2str(size(APHEFIS_DATA.data_t.data,1)) ];

text_d{op}{2}=[ '\rmP Treated:' text_table.data_t.data{op,text_table.data_t.iTotalP} ];
text_d{op}{3}=[ 'P Correct:' text_table.data_t.data{op,text_table.data_t.iCorrectP} ];
text_d{op}{4}=[ 'In Strehl:' text_table.data_t.data{op,text_table.data_t.iInStrehl} ];
text_d{op}{5}=[ 'Out Strehl:' text_table.data_t.data{op,text_table.data_t.iOutStrehl}];
text_d{op}{6}=[ 'Scintilation:' text_table.data_t.data{op,text_table.data_t.iScintilation} ];
text_d{op}{7}=[ 'Branchpoints:' text_table.data_t.data{op,text_table.data_t.iBranchpoints_csm} ];

text_d{op}{8}=[ 'Strehl impr:' text_table.static_stadistics.data{op,text_table.static_stadistics.istrehl_impr} ];
text_d{op}{9}=[ 'r0/Diameter:' text_table.static_stadistics.data{op,text_table.static_stadistics.ir0_diameter} ];

text_d{op}{10}=[ 'Diameter:' text_table.cr_input.data{op,text_table.cr_input.iapdiameter_meter} ];
text_d{op}{11}=[ 'Angle:' text_table.cr_input.data{op,text_table.cr_input.iiangle}];



end

