function [ found ] = APHEFIS_search( original,searching, margin, exactitude)

%
%   Search in the fields in original data with index subindex_o for fields
%   similar to searching, with a margin margin. The exactitude value fixes
%   how many relevant parameters we want to say that a field is similar to
%   another
%

% filter=original;
% filter.data_t.data=zeros(size(original.data_t.data));
% filter.data_t.data(:,[searching.data_t.iTotalP searching.data_t.iZonesP searching.data_t.iCorrectP searching.data_t.iInStrehl...
%         searching.data_t.iScintilation searching.data_t.iBranchpoints_csm searching.data_t.ir0])=1;
% 
% filter.static_stadistics.data=zeros(size(original.static_stadistics.data));    
% filter.static_stadistics.data(:,[filter.static_stadistics.istrehl_impr filter.static_stadistics.ir0_diameter])=1;
% 
% filter.cr_input.data=zeros(size(original.cr_input.data));    
% filter.cr_input.data(:,[filter.cr_input.iapdiameter_meter filter.cr_input.iiangle])=1;


filter.static_stadistics.data=zeros(size(original.static_stadistics.data));    
filter.static_stadistics.data(:,[filter.static_stadistics.ir0_diameter])=1;

total=sum(filter.data_t.data(1,:),2)+sum(filter.static_stadistics.data(1,:),2)+sum(filter.cr_input.data(1,:),2);

exactitude=exactitude*total;

if ~isstruct(margin)
    margin2=filter;
    margin2.data_t.data=filter.data_t.data*margin;
    margin2.static_stadistics.data=filter.static_stadistics.data*margin;
    margin2.cr_input.data=filter.cr_input.data*margin;
    margin=margin2;
    clear margin2
else
    margin.data_t.data=repmat(margin.data_t.data,size(filter.data_t.data,1),1);
    margin.static_stadistics.data=repmat(margin.static_stadistics.data,size(filter.static_stadistics.data,1),1);
    margin.cr_input.data=repmat(margin.cr_input.data,size(filter.cr_input.data,1),1);
end


searching.data_t.data=repmat(searching.data_t.data,size(filter.data_t.data,1),1);
searching.static_stadistics.data=repmat(searching.static_stadistics.data,size(filter.static_stadistics.data,1),1);
searching.cr_input.data=repmat(searching.cr_input.data,size(filter.cr_input.data,1),1);



resemblance=sum((original.data_t.data>(searching.data_t.data-margin.data_t.data)).*(original.data_t.data<(searching.data_t.data+margin.data_t.data)).*(filter.data_t.data>0),2)...
    +sum(((original.static_stadistics.data>(searching.static_stadistics.data-margin.static_stadistics.data)).*original.static_stadistics.data<(searching.static_stadistics.data+margin.static_stadistics.data)).*(filter.static_stadistics.data>0),2)...
    +sum(((original.cr_input.data>(searching.cr_input.data-margin.cr_input.data)).*original.cr_input.data<(searching.cr_input.data+margin.cr_input.data)).*(filter.cr_input.data>0),2);

original.data_t.columns=[original.data_t.columns 'Resemblance'];
original.data_t.data=[original.data_t.data resemblance];
found=APHEFIS_cut(original,resemblance>=exactitude);



end

