% HE_Aperture.m  based on HE=heteff(Rx,LO,PD) ;  DiGi 190203 , last change 080703
% berechnet die Leistungs(!!!)-Heterodyn-Effizienz fr den idealen conventionallen single-detector Receiver
% diese HetEff ist el. SNR-HE (nachher bei der el. SNR-Berechnung nicht nochmal quadrieren!)
%
% last change: 2009-07-21, Marion  Gdel
% berechnet die Heterodyn-Effizienz in der Apertur
% Rx				Empfangsfeld
% APdiam 			Durchmesser der Apertur-Maske [m]
% dxa 				[m / pix] in der Apertur
%
% needed functions: apmask_v2
% new DiGi 20091106: nur zwei paremeter: apdiam_pixel statt APdiam und dxa

function HE = HE_Aperture(Rx,diam_pixel) % HE of conventional Heterodyne Receiver

if (nargin<2)  
	error('HE_Aperture.m : not enough input parameters, function stopped!'); 
end	

dim1=size(Rx,1); dim2=size(Rx,2);

if dim1~=dim2 
	error('HE_Aperture : Field-Matrix is not square, function stopped!'); 
end

LO = double(apmask_v2(diam_pixel,dim1)); 

Nenner = sum( (( abs(LO(:)).^2  ))) * sum(( abs(Rx(:)).^2 ));
HE = ( (sum(LO(:).*conj(Rx(:)) )) *  (sum(sum(conj(LO(:)).*Rx(:)))) )  / Nenner; 
%disp(['HE_Aperture.m : time for  HetEff-calculation  : ', num2str(etime(clock,t0)),' Sekunden']);  

return