function [ phases,prof_length,prof_metric,prof_vecs ] = Metric4( field,peak_values ,sorting,min_factor,exp_threshold )
%   
%   Fourth option in the search for a correct metric to automaticaly determine the phases 
%   of the watersheed zones. 
%   
%   In this one, we divide the minimum of the line uniting the two points
%   by the mean between the two peaks.
%

aux=zeros(size(peak_values,1),size(exp_threshold,2));% Array with the values that will give us the sign of each zone

max_nearer=1;% How many peaks near each one will we evaluate
phases=zeros(size(peak_values,1),size(exp_threshold,2));

prof_length=zeros(size(peak_values,1)) ;  
prof_metric=zeros(size(peak_values,1));

for vec_a=1:size(peak_values,1) % counter for matrix-para, start peak
    for vec_b=1:size(peak_values,1) % counter for matrix-para, other peak 
        if vec_a ~= vec_b
            prof_vec = improfile(field, [peak_values(vec_a,2) peak_values(vec_b,2)] , [peak_values(vec_a,1) peak_values(vec_b,1)] ); % profile-vectors
            prof_vecs{vec_a,vec_b}=prof_vec;
            prof_length(vec_a,vec_b) = length(prof_vec);
            prof_metric(vec_a,vec_b) = -min(prof_vec) / (prof_vec(1)+prof_vec(length(prof_vec)));
        end
    end
end

prof_metric_mod=zeros(size(prof_metric,1),size(prof_metric,2),size(exp_threshold,2));




for i=1:size(exp_threshold,2)
	eval(['threshold=',exp_threshold{i}{1},';']);
	prof_metric_mod(:,:,i)=prof_metric-threshold;
	aux(1,i)=1;
end
	
if sorting==1
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%******1rst option for sorting zones: the bigger ones
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

i=2;
while (i<=size(peak_values,1))&&(peak_values(i,3)>=peak_values(1,3)/min_factor)% We limit too the min peak value
    nearer=zeros(max_nearer);
    nearer(1)=1;
    j=2;
    while j<i
       for k=1:max_nearer
            if nearer(k)==0||prof_length(i,j)<prof_length(i,nearer(k))
                nearer(k+1:max_nearer)=nearer(k:max_nearer-1);
                nearer(k)=j;
            end
       end
       j=j+1;
    end
    j=1;
    total_length=0;
    while (j<=max_nearer)&&(nearer(j)~=0)
       total_length=total_length+prof_length(i,nearer(j));
       for k=1:size(aux,2)
            aux(i,k)=aux(i,k)+sign(aux(nearer(j),k))*prof_metric_mod(i,nearer(j),k)/prof_length(i,nearer(j));
       end
       j=j+1; 
    end 
    
    i=i+1;
end
phases=sign(aux);


elseif sorting==2
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%******2nd option for sorting zones: the ones that are nearer to the maximum 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[sorted_l,nearer]=sort(prof_length);% obtains the indexes of the maximums sorted by it's distance to each other

i=2;
while (i<=size(peak_values,1))
    if (peak_values(i,3)>peak_values(1,3)/min_factor)% We limit too the min peak value
    j=1;
    k=2;
    total_length=0;
    while (j<=max_nearer)&&(j<i)%We look at the peaks ordering them by the distance to the first one
        if max(max(nearer(1:i,1)==nearer(k,nearer(i,1))))~=0
            total_length=total_length+prof_length(nearer(k,nearer(i,1)),nearer(i,1));%currently not used, but could be usefull to ponereate
            for l=1:size(aux,2)
                aux(nearer(i,1),l)=aux(nearer(i,1),l)+sign(aux(nearer(k,nearer(i,1)),l))*prof_metric_mod(nearer(i,1),nearer(k,nearer(i,1)),l)/prof_length(nearer(i,1),nearer(k,nearer(i,1)));
            end
            j=j+1;
        end
        k=k+1; 
    end 
    end
    i=i+1;
end


end

phases=sign(aux);

end