
function [APHEFIS_DATA]=Zernike_cicle(fil,zernikeN)
    
%
% APHEFIS_plot('r0_diameter',{'InStrehl','OutStrehl'},0,0,{'r0_diameter','r0_diameter'},{'>0.01','<2'})
% Function that extracts the information of an stored APHEFIS fields file,
% filters it by then specified conditions, and plot the results in a graphic
% 

if isstruct(file)
    if isfield(fil,'APHEFIS_DATA')
        data=fil.APHEFIS_DATA;
    else
        data=fil;
    end
elseif ischar(fil)&&exist(fil,'file')
    data=load(['./' fil],'-mat');
    data=data.APHEFIS_DATA;
else
    [FileName,PathName,FilterIndex] = uigetfile('.aph','File to Load the Data From:','APHEFIS_DATA.aph');
    data=load([PathName,FileName],'-mat');
    data=data.APHEFIS_DATA;
end


for f=1:size(data.data_t.rows)
    
    iphase=load(['./Phases/Inputs128/' data.cr_input.data(i,data.cr_input.iiangle) '/' data.cr_input.data(i,data.cr_input.iapdiameter_meter) '/field_' data.cr_input.data(i,data.cr_input.ibase_field) ],'-mat')
    ophase=load(['./Phases/Outputs128/' data.cr_input.data(i,data.cr_input.iiangle) '/' data.cr_input.data(i,data.cr_input.iapdiameter_meter) '/field_' data.cr_input.data(i,data.cr_input.ibase_field) ],'-mat')
    
    phif=imresize(phif,[64 64]);
    [ain,phiRec,rms]=MatchZernike(imresize(iphase,[64 64]),100);
    [aout,phiRec,rms]=MatchZernike(imresize(ophase,[64 64]),100);
    
    data.data_t.Zern_in=ain;
    data.data_t.Zern_out=aout;
end

APHEFIS_DATA=data;

save('./data_with_Zernike.aph','APHEFIS_DATA');

end