function C=acf2_Nicotoolbox(A)
% C=acf2(A)
% 2D-auto-correlation function. acf2 replaces xcorr2 because 
% it is too slow for large matrices. NiPe 23/09/03.
% 
% A is the matrix to be auto-correlated. If A is a matrix of
% integers, and integer elements or absolute zeros are expected
% for C, then round the ouput matrix C after calling acf2:
% e.g., C=round(C);
%
% copied from Nicotoolbox, 29. Juli 2009

[Ma Na]=size(A);


C=fft2(A,2*Ma-1,2*Na-1); % fft with zero padding
C=abs(C).^2;
C=ifft2(C);
% C=real(C); % no need to real actually
C=fftshift(C);