function g = angmat(gridsize)
% ANGMAT(M)
% ANGMAT([M N])
% ANGMAT([M N], [a b])
% returns the angle from the matrix center


if length(gridsize)==1
    gridsize(2) = gridsize;
end

x = oddvec(gridsize(1));
y = -oddvec(gridsize(2));

[x,y] = meshgrid(x,y);

g = atan2(y,x);
