% function mask = apmask_v2(apdiapix,apmatpix) 
% 
% function creates a aperture-mask
% apmatpix = size of matrix (square)
% apdiapix = size of aperture (diameter) 
% circular aperture is in the center of the matrix 
%
% apmask.m DiGi start lang ists her; last change: 090503: faster algorithm
% without loops, now only 1s instead of 19s

function mask = apmask_v2(apdiapix,apmatpix) 
% generate 1 square-meter aperture-matrizes; apsize is in meters
% apmatpix is the calculated mask matrix-size, to have 1m output-matrix with dx=2mm apmatpix must be 500
if nargin<2 
    error('apmask_v2: apmatpix is missing in function call'); 
    return; 
end % aperture-matrix resolution should always be 2mm
if apdiapix<1
    error('apmask_v2: "apdiapix" is not in pixels');
    return
end

%mask=zeros(apmatpix,apmatpix);

% apdiapix = 100; apmatpix = 1024; % nur zum Test

N   = apmatpix;
lim = round(N/2);

X=repmat([-lim:2*lim/(N-1):lim],[N 1]);
Y=repmat([-lim:2*lim/(N-1):lim]',[1 N]);

R=sqrt(X.^2+Y.^2);

mask = (R <= apdiapix/2);

% figure; imagesc(mask);

return

%%%% old and slow:

% ^apradisqr = ( (apdiapix/2) + .5)^2;

% for k=1:apmatpix
%   for l=1:apmatpix
%      mask(k,l)=( (apmatpix/2-k+1)^2+(apmatpix/2-l+1)^2 < apradisqr);
%   end
% end
% figs3=1; if figs3 figure(777); imagesc(mask); end   

