function g = distmat(gridsize, scale)
% Distance Matrix:
% DISTMAT(M)
% DISTMAT([M N])
% DISTMAT([M N], [a b])
% returns the distances from the matrix center
% [a b] scales the x and y dimensions resp.


if length(gridsize)==1
    gridsize(2) = gridsize;
end

x = oddvec(gridsize(1));
y = oddvec(gridsize(2));

if nargin > 1
    x = scale(1)*x;
    y = scale(2)*y;
end

g = repmat((x.^2)', [1, gridsize(2)]);
g = g + repmat(y.^2, [gridsize(1), 1]);
g = sqrt(g);