function g = distmat_Nicotoolbox(gridsize, scale)
% Distance Matrix:
% DISTMAT(M)
% DISTMAT([M N])
% DISTMAT([M N], [a b])
% returns the distances from the matrix center
% [a b] scales the x and y dimensions resp.
%
% copied from Nicotoolbox, 29. Juli 2009
% called by: rotataverage --> apmask --> distmat
% needed functions: oddvec_Nicotoolbox


if length(gridsize)==1
    gridsize(2) = gridsize;
end

x = oddvec_Nicotoolbox(gridsize(1));
y = oddvec_Nicotoolbox(gridsize(2));

if nargin > 1
    x = scale(1)*x;
    y = scale(2)*y;
end

g = repmat((x.^2)', [1, gridsize(2)]);
g = g + repmat(y.^2, [gridsize(1), 1]);
g = sqrt(g);