function [theta, J_history] = gradientDescentMulti(X, y, theta, alpha, num_iters)
%GRADIENTDESCENTMULTI Performs gradient descent to learn theta
%   theta = GRADIENTDESCENTMULTI(x, y, theta, alpha, num_iters) updates theta by
%   taking num_iters gradient steps with learning rate alpha

m = length(y); % number of training examples
J_history = zeros(num_iters, 1);
pond=ones(size(theta));
iter=1;
while iter<num_iters
    grad=(X'*(X*theta-y))/m;
    pond=abs(grad/sum(grad));
    theta0=theta;
    theta=theta-alpha*pond.*grad;
    J_history(iter) = (X*theta-y)'*(X*theta-y)/2/m;
    if iter>1&&J_history(iter)>J_history(iter-1)
        alpha=alpha/5;
        theta=theta0;
        iter=iter-1;
    elseif iter>1&&J_history(iter-1)/J_history(iter)<2
        alpha=alpha*1.2;
    end
    iter=iter+1;
end

end
