
function [ theta mu sigma ] = lineal_aproximation( X,y,option)

% Option 1: Gradient descent
% Option 2: Normal equation

[m,n] = size(X);


% Add intercept term to X
[X mu sigma] = featureNormalize(X);
X = [ones(m, 1) X];

if option==1
    % Choose some alpha value
    alpha = 0.001;
    num_iters = 500;
    
    % Init Theta and Run Gradient Descent 
    theta = zeros(n+1, 1);
    [theta, J_history] = gradientDescentMulti(X, y, theta, alpha, num_iters);

else
    % Calculate the parameters from the normal equation
    theta = normalEqn(X, y);
end


end
