function [J grad] = nnCostFunction(nn_params, input_layer_size,hidden_layer_size, num_labels, hidden_layers,num_packets, y, lambda)
%NNCOSTFUNCTION Implements the neural network cost function for a two layer
%neural network which performs classification
%   [J grad] = NNCOSTFUNCTON(nn_params, hidden_layer_size, num_labels, ...
%   X, y, lambda) computes the cost and gradient of the neural network.  
% 
%   The returned parameter grad should be a "unrolled" vector of the
%   partial derivatives of the neural network.
%


% Setup some useful variables
m = size(y, 1);

J = 0;


if hidden_layers>0
    Theta{1} = reshape(nn_params(1:hidden_layer_size * (input_layer_size + 1)), hidden_layer_size, (input_layer_size + 1));
end
for i=2:hidden_layers
    Theta{i} = reshape(nn_params((1 + (hidden_layer_size * (input_layer_size+1))+(i-2)*(hidden_layer_size * (hidden_layer_size+1))):...
        ((hidden_layer_size * (input_layer_size+1))+(i-1)*(hidden_layer_size * (hidden_layer_size + 1)))),hidden_layer_size, (hidden_layer_size + 1));
end
Theta{hidden_layers+1} = reshape(nn_params((1 + ((hidden_layer_size * (input_layer_size+1))+(hidden_layers-1)*(hidden_layer_size * (hidden_layer_size + 1)))*(hidden_layers>0))...
    :end),num_labels, ((hidden_layers>0)*hidden_layer_size+(hidden_layers==0)*input_layer_size + 1));

clear nn_params;

numelx=1;
for p=1:num_packets
    eval(['aux=load([' 39 'x_norm' 39 ' num2str(p) ' 39 '.tmp' 39 '],' 39 '-mat' 39 ');' ]);
    a{1}=aux.x_norm;
    clear aux
    for i=2:hidden_layers+2
        a{i-1}=[ones(size(a{i-1},1),1) a{i-1}];
        z{i}=a{i-1}*Theta{i-1}.';
        a{i}=sigmoid(z{i});
    end
    h(numelx:numelx+size(a{1},1)-1,:)=a{hidden_layers+2};
    numelx=numelx+size(a{1},1);
    eval(['save az' num2str(p) '.tmp a z']); 
end
J=sum(sum(-y.*log(h)-(1-y).*log(1-h)))/m;


for i=1:hidden_layers+1
    Theta_prima_0=Theta{i};
    Theta_prima{i}=Theta_prima_0(:,2:end);
    J=J+(sum(sum(Theta_prima_0.^2)))*lambda/(2*m);
    Theta_grad{i}=[zeros(size(Theta{i},1),1),Theta_prima{i}]*lambda;
end


% 
% grad=[];
% delta{hidden_layers+2}=h-y;
% 
% for i=(hidden_layers+1):-1:2
%     delta{i}=delta{i+1}*Theta_prima{i}.*sigmoidGradient(z{i});
%     Theta_grad{i}=Theta_grad{i}+delta{i+1}.'*a{i};        
%     Theta_grad{i}=Theta_grad{i}/m;
%     grad=[Theta_grad{i}(:);grad];
% end
% Theta_grad{1}=Theta_grad{1}+delta{2}.'*a{1};
% Theta_grad{1}=Theta_grad{1}/m;
% grad=[Theta_grad{1}(:);grad];
% 


% tic
grad=[];
numelx=1;
for p=1:num_packets
    eval(['aux=load([' 39 'az' 39 ' num2str(p) ' 39 '.tmp' 39 '],' 39 '-mat' 39 ');' ]);
    a=aux.a;
    z=aux.z;
    clear aux;
    delta{hidden_layers+2}=h(numelx:numelx+size(a{1},1)-1,:)-y(numelx:numelx+size(a{1},1)-1,:);
    
    for i=(hidden_layers+1):-1:2
        delta{i}=delta{i+1}*Theta_prima{i}.*sigmoidGradient(z{i});
        Theta_grad{i}=Theta_grad{i}+delta{i+1}.'*a{i};  
        if p==num_packets
            Theta_grad{i}=Theta_grad{i}/m;
            grad=[Theta_grad{i}(:);grad];
        end
    end
    
    Theta_grad{1}=Theta_grad{1}+delta{2}.'*a{1};
    
    if p==num_packets
        Theta_grad{1}=Theta_grad{1}/m;
        grad=[Theta_grad{1}(:);grad];       
    end
    
    numelx=numelx+size(a{1},1);
end
% toc
% pause

end
