function peak_values = peaks_xy_dg_mod(localmax_pixels,watersh, max_number,mode, gflag)
% test with:   peaks_xy_dg(localmax_pixels, 5) 
% Based on peaks_xy_dg.m, DiGi 20100203, based on localpeaks2_dg.m
% last change 20111012
% calculates the order and coordinates of the local-peaks-matrix given through the following lines using "imregionalmax.m" (ImageProcTB):
% localmax_pixels = intensitymatrix .* imregionalmax(intensitymatrix,8);
% If mode=0, calculates the highests peaks. If its 1, calculates the
% nearest to the maximum
%
if (nargin<5)
    gflag=0;
end
if (nargin<2)  
    mode=1;
elseif (mode==0&&nargin<4) 
    error('peaks_xy_dg_mod.m : not enough input parameters, function stopped!');     
end
if gflag figure(51010); upos = [100, 200, 800 , 400]; set(gcf,'Position',upos); set(gcf,'Color',[1 1 1]); %caxis([0 max(max(localmax_pixels))]); end
end
matrixsize = size(localmax_pixels,1);

% focal intensy calculation tends to produce unwanted local maxima at the matrix edge, these are removed first:
localmax_pixels(1:matrixsize , 1) = 0;
localmax_pixels(1:matrixsize , matrixsize) = 0;
localmax_pixels(1 , 1:matrixsize) = 0;
localmax_pixels(matrixsize , 1:matrixsize) = 0;

% if requested number of maxima is larger than the number of maxima detected by imregionalmax it is reduced accordingly:
sslp = sum(sum(localmax_pixels>0)); if max_number > sslp  max_number = sslp; end  % sslp: sum sum of localmax_pixels

if gflag subplot(1,2,1); imagesc(localmax_pixels); axis square; title(strcat('number of peaks = ',num2str(sslp))); 
    subplot(1,2,2); imagesc(localmax_pixels>0); axis square; title('All Peaks'); colormap(hot);
end


peak_values=zeros(max_number,3);

if mode==0
    peak_values=zeros(max_number,3);
    for i = 1 : max_number
        peak_values(i,3) = max(max(localmax_pixels));
        [a , b] = find(localmax_pixels == peak_values(i,3));
        peak_values(i,1)=a(1);
        peak_values(i,2)=b(1);
        localmax_pixels(watersh==watersh(peak_values(i,1) , peak_values(i,2) )) = 0;
    end
else
    sort_peaks=zeros(sslp,4);
    aux=zeros(1,4);
    sort_peaks(1,3) = max(max(localmax_pixels));
    [sort_peaks(1,1) , sort_peaks(1,2)] = find(localmax_pixels == sort_peaks(1,3));
    sort_peaks(1,4)=0;
    localmax_pixels(watersh==watersh(sort_peaks(1,1) , sort_peaks(1,2) )) = 0;   
    i=1;
    Mtest = max(max(localmax_pixels));
    while (Mtest>0)
        aux(1,3) = Mtest;
        [aux(1,1) , aux(1,2)] = find(localmax_pixels == aux(1,3),1);
        aux(1,4)=(aux(1,1)-sort_peaks(1,1))^2+(aux(1,2)-sort_peaks(1,2))^2;
        for j=1:i
            if aux(1,4)<sort_peaks(j,4)
                i=i+1;
                sort_peaks(j+1:i,:)=sort_peaks(j:i-1,:);
                sort_peaks(j,:)=aux;
                break;
            elseif j==i      
                i=i+1;
                sort_peaks(i,:)=aux;
                break;
            end
        end
        localmax_pixels(watersh==watersh(aux(1,1) , aux(1,2) )) = 0;

        Mtest = max(max(localmax_pixels));
    end
    [a,sort_peaks(1:max_number,4)]=sort(sort_peaks(1:max_number,3),1,'descend');
    sort_peaks(1:max_number,1:3)=sort_peaks(sort_peaks(1:max_number,4),1:3);
    peak_values=sort_peaks(1:max_number,1:3);

end
%if gflag figure(5503); imagesc(ampmatrix);  axis square; end
return;



