function [v, d] = rotataverage_Nicotoolbox(m, discmask, roundingflag)
% [v,d] = rotataverage(m, discmask, roundingflag)
% rotataverage averages a 2D  field over 
% its rotation angle 
% discmask = 'disc' for only circular valid area
%
% NiPe 04/08/05
%
% copied from Nicotoolbox, 29. Juli 2009
% needed functions: apmask_Nicotoolbox, distmat_Nicotoolbox


if size(m,1) ~= size(m,2)
    error('m must be square');
end

M = size(m,1);
% if ~mod(M,2)
%     error('m must have an odd size');
% end


distvec = distmat_Nicotoolbox(M); % round cause we need indices

if isempty(discmask)
    distvec = distvec(:);
    m = m(:);
else
    logmask = logical(apmask_Nicotoolbox(M)); % with apmask there should be no distance > (M-1)/2
    distvec = distvec(logmask);
    m = m(logmask);
end

% here distm must be integers!!
[sorted_distances, indices_of_sorted] = sort(distvec); % create look-up table
clear distvec;


if roundingflag
    sorted_distances = round(sorted_distances);
end

diffvec = diff(sorted_distances); % get 0s if adjacent values are equal.
iv = [1:length(sorted_distances)]'; % indices vector
first_inds = iv( [1; diffvec] ~= 0 );
clear diffvec;
clear iv;

block_lens = diff([ first_inds; (length(sorted_distances)+1) ]);

d = sorted_distances(first_inds);
clear sorted_distances;

v = [];
for ibl = 1:length(first_inds)
    
    this_ivec = [0:block_lens(ibl)-1] + first_inds(ibl);
    this_block_indices = indices_of_sorted(this_ivec);
    v = [v; sum( m(this_block_indices) )];
    
end

v = v./block_lens; % we have to get mean values


